class X2Ability_Rogue2AbilitySet extends X2Ability_SharpshooterAbilitySet
	dependson (XComGameStateContext_Ability) config(RogueAbilities);

	static function array<X2DataTemplate> CreateTemplates()
{
	local array<X2DataTemplate> Templates;
	
	Templates.AddItem(IsmsReducedThreat());
 	Templates.AddItem(IsmsRemoveThreat());
	Templates.AddItem(IsmsHealWhenAttacked());
    Templates.AddItem(ReturnFire4());
//
	Templates.AddItem(ConcussiveShot3Ability());
//	Templates.AddItem(IsmsRiposte2());
	Templates.AddItem(RogueUnderCover());
//	Templates.AddItem(IsmsNBK());
//	Templates.AddItem(IsmsNBK2());	
	//Templates.AddItem(IsmsNBK3());	
//	Templates.AddItem(IsmsBattleRush());
	Templates.AddItem(IsmsBluff());
//	Templates.AddItem(IsmsHitAndRun());	 
	Templates.AddItem(IsmsLoneWolfPack());
	Templates.AddItem(RogueAndGunAbility());
	Templates.AddItem(IsmsRogueAndGunMove()); 

	return Templates;
}

 static function X2AbilityTemplate IsmsReducedThreat()
{
	local X2AbilityTemplate						Template;
	local X2AbilityTargetStyle                  TargetStyle;
	local X2AbilityTrigger						Trigger;
	local X2Effect_ReturnFire                   FireEffect;
	local X2Effect_Persistent				MarkedEffect;  //added



	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsReducedThreat');

	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_Riposte";

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	
	Template.AdditionalAbilities.AddItem('IsmsRemoveThreat');

	Template.AbilityToHitCalc = default.DeadEye;


	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';		//HERE HERE CHANGE TO END OF TURN ACTIVATE
	Template.AbilityTriggers.AddItem(Trigger);

	FireEffect = new class'X2Effect_ReturnFire';

	FireEffect.AbilityToActivate = 'IsmsRemoveThreat';  //here here here here here below false to true
	FireEffect.bPreEmptiveFire = true;
	FireEffect.MaxPointsPerTurn = 1;
	FireEffect.GrantActionPoint = 'riposte';
	FireEffect.BuildPersistentEffect(1, false, false, false, eGameRule_PlayerTurnBegin);
	FireEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	Template.AddTargetEffect(FireEffect);


	//MarkedEffect = class'X2Effect_RogueCreateMarkedEffect'.static.CreateReducedThreatEffect(2, false);
	MarkedEffect = class'X2Effect_RogueCreateMarkedEffect'.static.CreateTauntEffect(6, false);
	//Template.AddShooterEffect(MarkedEffect); 
	Template.AddTargetEffect(MarkedEffect);


	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!

	Template.bCrossClassEligible = false;       //  this can only work with pistols, which only sharpshooters have

	return Template;
}



static function X2AbilityTemplate IsmsRemoveThreat()
{
	local X2AbilityTemplate                 Template;
//	local X2Condition_Visibility            TargetVisibilityCondition;
 	local X2AbilityToHitCalc_StandardAim    ToHitCalc;
//	local X2Condition_UnitProperty          TargetPropertyCondition;
//	local X2Condition_UnitProperty          ShooterPropertyCondition;
//	local X2Effect_ImmediateAbilityActivation ImpairingAbilityEffect;
	//local X2Effect_ApplyWeaponDamage        WeaponDamageEffect;
//	local X2AbilityCost_ReserveActionPoints ReserveActionPointCost;
	//local X2AbilityCooldown                 Cooldown;
	local X2Effect_RemoveEffects						RemoveEffects;
	local X2AbilityTrigger_EventListener    Trigger;
	local X2Effect_ApplyMedikitHeal         MedikitHeal;
 

	//`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsRemoveReducedThreat');
	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsRemoveThreat'); 



	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_Riposte";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_ShowIfAvailable;
	Template.Hostility = eHostility_Offensive;
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_SERGEANT_PRIORITY;
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";

//	Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
//	Template.bUsesFiringCamera = true;
//	Template.CinescriptCameraType = "StandardGunFiring";

 
	//ToHitCalc = new class'X2AbilityToHitCalc_StandardAim';
////	ToHitCalc.FinalMultiplier = -0.20f;
	//ToHitCalc.bGuaranteedHit = true;
	//ToHitCalc.bAllowCrit = true;
	//ToHitCalc.bHitsAreCrits = false;
	//Template.AbilityToHitCalc = ToHitCalc;

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;

	//Trigger = new class'X2AbilityTrigger_EventListener';
	//Trigger.ListenerData.Deferral = ELD_OnStateSubmitted;
	//Trigger.ListenerData.EventID = 'PlayerTurnEnded';
	//Trigger.ListenerData.Filter = eFilter_Player;
 	//Trigger.ListenerData.EventFn = class'XComGameState_Ability'.static.AbilityTriggerEventListener_Self;
	//Template.AbilityTriggers.AddItem(Trigger);

	MedikitHeal = new class'X2Effect_ApplyMedikitHeal';
	MedikitHeal.PerUseHP = 2;
	MedikitHeal.IncreasedHealProject = 'BattlefieldMedicine';
	MedikitHeal.IncreasedPerUseHP = class'X2Ability_DefaultAbilitySet'.default.NANOMEDIKIT_PERUSEHP;
	Template.AddShooterEffect(MedikitHeal);	


	//Trigger = new class'X2AbilityTrigger_PlayerInput';
	//Template.AbilityTriggers.AddItem(Trigger);

	//Cooldown = new class'X2AbilityCooldown';
	//Cooldown.iNumTurns = 2;
	//Template.AbilityCooldown = Cooldown;


 //	Template.bDontDisplayInAbilitySummary = true;
 
 	//ReserveActionPointCost = new class'X2AbilityCost_ReserveActionPoints';
 	//ReserveActionPointCost.iNumPoints = 0;
 	//ReserveActionPointCost.AllowedTypes.AddItem('riposte'); //here here
 	//Template.AbilityCosts.AddItem(ReserveActionPointCost);
 
 	RemoveEffects = new class'X2Effect_RemoveEffects';
 	RemoveEffects.EffectNamesToRemove.AddItem('Taunt');
 	Template.AddShooterEffect(RemoveEffects);
 

	Template.AbilityTargetStyle = default.SimpleSingleTarget;
//	Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);

	//Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	//Template.AddShooterEffectExclusions();  //HERE HERE?

	//TargetVisibilityCondition = new class'X2Condition_Visibility';
	//TargetVisibilityCondition.bRequireGameplayVisible = true;
	//TargetVisibilityCondition.bAllowSquadsight = true;
	//Template.AbilityTargetConditions.AddItem(TargetVisibilityCondition);
	//Template.AbilityTargetConditions.AddItem(default.LivingHostileTargetProperty);
//
	//  Put holo target effect first because if the target dies from this shot, it will be too late to notify the effect.
	//Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	//Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());

	//Template.bAllowAmmoEffects = true;
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;

	Template.bCrossClassEligible = false;

	// Target Conditions
	//
	//TargetPropertyCondition = new class'X2Condition_UnitProperty';	
	//TargetPropertyCondition.ExcludeDead = true;                     //Can't target dead
	//TargetPropertyCondition.ExcludeFriendlyToSource = true;         //Can't target friendlies
	//Template.AbilityTargetConditions.AddItem(TargetPropertyCondition);

	// Shooter Conditions
	//
	//ShooterPropertyCondition = new class'X2Condition_UnitProperty';	
	//ShooterPropertyCondition.ExcludeDead = true;                    //Can't shoot while dead
	//Template.AbilityShooterConditions.AddItem(ShooterPropertyCondition);

	//Impairing effects need to come before the damage. This is needed for proper visualization ordering.
	//Effect on a successful melee attack is triggering the Apply Impairing Effect Ability
	//ImpairingAbilityEffect = new class 'X2Effect_ImmediateAbilityActivation';
	//ImpairingAbilityEffect.BuildPersistentEffect(1, false, true, , eGameRule_PlayerTurnBegin);
	//ImpairingAbilityEffect.EffectName = 'ImmediateStunImpair';
	//ImpairingAbilityEffect.AbilityName = 'RiposteShot';
	//ImpairingAbilityEffect.bRemoveWhenTargetDies = true;
	//ImpairingAbilityEffect.VisualizationFn = ImpairingAbilityEffectTriggeredVisualization;
	//Template.AddTargetEffect(ImpairingAbilityEffect);

	// Damage Effect
	//
	//WeaponDamageEffect = new class'X2Effect_ApplyWeaponDamage';
	//WeaponDamageEffect.DamageTypes.AddItem('Electrical');
//	Template.AddTargetEffect(WeaponDamageEffect);

 




	return Template;
}

static function X2AbilityTemplate IsmsHealWhenAttacked()
{
	local X2AbilityTemplate                 Template;
	local X2AbilityTrigger_EventListener    Trigger;
	//local X2Condition_UnitValue				ShooterCondition;	 
	//local X2Effect_RemoveEffects			RemoveEffects;
	//local X2Effect_RemoveEffectsByDamageType RemoveEffectTypes;
	local X2Effect_ApplyMedikitHeal         MedikitHeal;
	//local X2Condition_UnitEffects			ShooterEffects;
					 
	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsHealWhenAttacked');

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;

	Trigger = new class'X2AbilityTrigger_EventListener';
	Trigger.ListenerData.Deferral = ELD_OnStateSubmitted;
	Trigger.ListenerData.EventID = 'UnitAttacked';  //UnitAttacked  //PlayerTurnEnded
	Trigger.ListenerData.Filter = eFilter_Player;
 	Trigger.ListenerData.EventFn = class'XComGameState_Ability'.static.AbilityTriggerEventListener_Self;
	Template.AbilityTriggers.AddItem(Trigger);

	
	//ShooterCondition = new class'X2Condition_UnitValue';
 	//ShooterCondition.AddCheckValue('NonMoveActionsThisTurn', 0);
 	//Template.AbilityShooterConditions.AddItem(ShooterCondition);

//	ShooterEffects = new class'X2Condition_UnitEffects';
 //	ShooterEffects.AddRequireEffect(class'X2StatusEffects'.default.BurningName, 'AA_UnitIsNotBurning');
	
 	//Template.AbilityShooterConditions.AddItem(ShooterEffects);
	
	//RemoveEffects = new class'X2Effect_RemoveEffects';
 	//RemoveEffects.EffectNamesToRemove.AddItem(class'X2StatusEffects'.default.BurningName);
	//RemoveEffects.EffectNamesToRemove.AddItem(class'X2StatusEffects'.default.AcidBurningName);
	//RemoveEffects.EffectNamesToRemove.AddItem(class'X2StatusEffects'.default. MarkedName);
	//RemoveEffects.EffectNamesToRemove.AddItem(class'X2StatusEffects'.default.PoisonedName);
	//Template.AddTargetEffect(RemoveEffects);

	//RemoveEffectTypes = new class'X2Effect_RemoveEffectsByDamageType';
	//RemoveEffectTypes.DamageTypesToRemove.AddItem('Fire');
	//RemoveEffectTypes.DamageTypesToRemove.AddItem('Poison');
	//RemoveEffectTypes.DamageTypesToRemove.AddItem(class'X2Effect_ParthenogenicPoison'.default.ParthenogenicPoisonType);
	//RemoveEffectTypes.DamageTypesToRemove.AddItem('Acid');
	 

	MedikitHeal = new class'X2Effect_ApplyMedikitHeal';
	MedikitHeal.PerUseHP = 2;
	MedikitHeal.IncreasedHealProject = 'BattlefieldMedicine';
	MedikitHeal.IncreasedPerUseHP = class'X2Ability_DefaultAbilitySet'.default.NANOMEDIKIT_PERUSEHP;
	Template.AddTargetEffect(MedikitHeal);	

	Template.CustomSelfFireAnim = 'FF_FireMedkitSelf';
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
		
	Template.PostActivationEvents.AddItem('ItemRecalled');
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization; 
	return Template;
}

static function X2AbilityTemplate ReturnFire4()
{
	local X2AbilityTemplate						Template;
	local X2AbilityTargetStyle                  TargetStyle;
	local X2AbilityTrigger						Trigger;
	local X2Effect_ReturnFire                   FireEffect;
	local X2AbilityCost_ActionPoints        ActionPointCost; 
	local X2AbilityCooldown                 Cooldown;
	local X2Effect_Persistent				MarkedEffect; 
	//local X2Effect_PersistentStatChange		PersistentStatChangeEffect;
	local X2Condition_UnitProperty          ShooterPropertyCondition;
	//local X2Effect_Marked                   MarkedEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'ReturnFire4');
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_Riposte";

	Template.AdditionalAbilities.AddItem('IsmsRemoveThreat');
//	 Template.AdditionalAbilities.AddItem('RiposteShot');

//	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.AbilitySourceName = 'eAbilitySource_Standard';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_ShowIfAvailable;
	//Sound Test Here
	//Template.AbilityConfirmSound = "SoundCivilianFemaleScreams.CivFemaleScreamsOffscreenCue";
	//Sound test here
	
	Template.Hostility = eHostility_Neutral;

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	//Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Trigger = new class'X2AbilityTrigger_PlayerInput';
	Template.AbilityTriggers.AddItem(Trigger);

	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 1;
	ActionPointCost.bConsumeAllPoints = true;
	Template.AbilityCosts.AddItem(ActionPointCost);

 	Cooldown = new class'X2AbilityCooldown';
	Cooldown.iNumTurns = 2;
	Template.AbilityCooldown = Cooldown;

	ShooterPropertyCondition = new class'X2Condition_UnitProperty';	
	ShooterPropertyCondition.ExcludeDead = true;                    //Can't shoot while dead
	//ShooterPropertyCondition.ExcludePanicked = true;
	ShooterPropertyCondition.ExcludeInStasis = true;
	ShooterPropertyCondition.ExcludeStunned = true;
	Template.AbilityShooterConditions.AddItem(ShooterPropertyCondition);

	//PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	//PersistentStatChangeEffect.EffectName = 'TauntDodge';
	//PersistentStatChangeEffect.BuildPersistentEffect(1 /* Turns */,,,,eGameRule_PlayerTurnBegin);
	//PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, Template.GetMyHelpText(), Template.IconImage);
	//PersistentStatChangeEffect.AddPersistentStatChange(eStat_ArmorMitigation, 20);
	//PersistentStatChangeEffect.AddPersistentStatChange(eStat_ArmorChance, 100);
	//PersistentStatChangeEffect.AddPersistentStatChange(eStat_Defense, 22);
	//PersistentStatChangeEffect.DuplicateResponse = eDupe_Refresh;
	//Template.AddTargetEffect(PersistentStatChangeEffect);



	FireEffect = new class'X2Effect_ReturnFire';
	FireEffect.AbilityToActivate = 'IsmsRemoveThreat';  //here here here here here below false to true
	FireEffect.bPreEmptiveFire = true;
	FireEffect.MaxPointsPerTurn = 1;
	FireEffect.GrantActionPoint = 'riposte';
	FireEffect.BuildPersistentEffect(1, false, false, false, eGameRule_PlayerTurnBegin);
	FireEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	Template.AddTargetEffect(FireEffect);
	
	MarkedEffect = class'X2Effect_RogueCreateMarkedEffect'.static.CreateTauntEffect(2, false);
 
	Template.AddTargetEffect(MarkedEffect); 
 
  


	//Template.ActivationSpeech = 'SoldierRestsMindControl';

	Template.CustomFireAnim = 'HL_Psi_SelfCast';
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
//	Template.BuildVisualizationFn = None;
	Template.BuildInterruptGameStateFn = TypicalAbility_BuildInterruptGameState;
	//Template.BuildVisualizationFn = TargetGettingMarked_BuildVisualization;
	Template.BuildVisualizationFn = Riposte_BuildVisualization;
	//  NOTE: No visualization on purpose!

	Template.bCrossClassEligible = false;       //  this can only work with pistols, which only sharpshooters have

	return Template;
}

static function X2AbilityTemplate ConcussiveShot3Ability()
{
	local X2AbilityTemplate                 Template;
  
	local X2Condition_Visibility            TargetVisibilityCondition;
 
 	local X2AbilityToHitCalc_StandardAim    ToHitCalc;
	local X2Condition_UnitProperty          TargetPropertyCondition;
	local X2Condition_UnitProperty          ShooterPropertyCondition;
	local X2Effect_ImmediateAbilityActivation ImpairingAbilityEffect;
	//local X2Effect_ApplyWeaponDamage        WeaponDamageEffect;
	local X2AbilityCost_ReserveActionPoints ReserveActionPointCost;
	local X2AbilityCooldown                 Cooldown;
	local X2Effect_RemoveEffects						RemoveEffects;

 
	`CREATE_X2ABILITY_TEMPLATE(Template, 'ConcussiveShot3');

// 	Template.AdditionalAbilities.AddItem('RiposteShot');
//	Template.AdditionalAbilities.AddItem('ReturnFire3');

	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_Riposte";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_ShowIfAvailable;
	Template.Hostility = eHostility_Offensive;
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_SERGEANT_PRIORITY;
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";

	Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
	Template.bUsesFiringCamera = true;
	Template.CinescriptCameraType = "StandardGunFiring";

 
	ToHitCalc = new class'X2AbilityToHitCalc_StandardAim';
//	ToHitCalc.FinalMultiplier = -0.20f;
	ToHitCalc.bGuaranteedHit = true;
	ToHitCalc.bAllowCrit = true;
	ToHitCalc.bHitsAreCrits = false;
	Template.AbilityToHitCalc = ToHitCalc;
 
	Cooldown = new class'X2AbilityCooldown';
	Cooldown.iNumTurns = 2;
	Template.AbilityCooldown = Cooldown;


 	Template.bDontDisplayInAbilitySummary = true;
 	ReserveActionPointCost = new class'X2AbilityCost_ReserveActionPoints';
 	ReserveActionPointCost.iNumPoints = 1;
 	ReserveActionPointCost.AllowedTypes.AddItem('riposte'); //here here
 	Template.AbilityCosts.AddItem(ReserveActionPointCost);
 
 	RemoveEffects = new class'X2Effect_RemoveEffects';
 	RemoveEffects.EffectNamesToRemove.AddItem('Taunt');
 	Template.AddShooterEffect(RemoveEffects);
 

	Template.AbilityTargetStyle = default.SimpleSingleTarget;
//	Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	Template.AddShooterEffectExclusions();

	TargetVisibilityCondition = new class'X2Condition_Visibility';
	TargetVisibilityCondition.bRequireGameplayVisible = true;
	TargetVisibilityCondition.bAllowSquadsight = true;
	Template.AbilityTargetConditions.AddItem(TargetVisibilityCondition);
	Template.AbilityTargetConditions.AddItem(default.LivingHostileTargetProperty);

	//  Put holo target effect first because if the target dies from this shot, it will be too late to notify the effect.
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());

	Template.bAllowAmmoEffects = true;
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;

	Template.bCrossClassEligible = false;

	// Target Conditions
	//
	TargetPropertyCondition = new class'X2Condition_UnitProperty';	
	TargetPropertyCondition.ExcludeDead = true;                     //Can't target dead
	TargetPropertyCondition.ExcludeFriendlyToSource = true;         //Can't target friendlies
	Template.AbilityTargetConditions.AddItem(TargetPropertyCondition);

	// Shooter Conditions
	//
	ShooterPropertyCondition = new class'X2Condition_UnitProperty';	
	ShooterPropertyCondition.ExcludeDead = true;                    //Can't shoot while dead
	Template.AbilityShooterConditions.AddItem(ShooterPropertyCondition);

	//Impairing effects need to come before the damage. This is needed for proper visualization ordering.
	//Effect on a successful melee attack is triggering the Apply Impairing Effect Ability
	ImpairingAbilityEffect = new class 'X2Effect_ImmediateAbilityActivation';
	ImpairingAbilityEffect.BuildPersistentEffect(1, false, true, , eGameRule_PlayerTurnBegin);
	ImpairingAbilityEffect.EffectName = 'ImmediateStunImpair';
	ImpairingAbilityEffect.AbilityName = 'RiposteShot';
	ImpairingAbilityEffect.bRemoveWhenTargetDies = true;
	ImpairingAbilityEffect.VisualizationFn = ImpairingAbilityEffectTriggeredVisualization;
	Template.AddTargetEffect(ImpairingAbilityEffect);

	// Damage Effect
	//
	//WeaponDamageEffect = new class'X2Effect_ApplyWeaponDamage';
	//WeaponDamageEffect.DamageTypes.AddItem('Electrical');
//	Template.AddTargetEffect(WeaponDamageEffect);

 




	return Template;
}


static function ImpairingAbilityEffectTriggeredVisualization(XComGameState VisualizeGameState, out VisualizationTrack BuildTrack, const name EffectApplyResult)
{
	local XComGameStateContext_Ability AbilityContext;
	local XComGameStateContext Context;
	local XComGameStateContext_Ability TestAbilityContext;
	local int i, j;
	local XComGameStateHistory History;
	local bool bAbilityWasSuccess;
	local X2AbilityTemplate AbilityTemplate;
	local X2VisualizerInterface TargetVisualizerInterface;

	if( (EffectApplyResult != 'AA_Success') || (XComGameState_Unit(BuildTrack.StateObject_NewState) == none) )
	{
		return;
	}

	Context = VisualizeGameState.GetContext();
	AbilityContext = XComGameStateContext_Ability(Context);

	if( AbilityContext.EventChainStartIndex != 0 )
	{
		History = `XCOMHISTORY;

		// This GameState is part of a chain, which means there may be a stun to the target
		for( i = AbilityContext.EventChainStartIndex; !Context.bLastEventInChain; ++i )
		{
			Context = History.GetGameStateFromHistory(i).GetContext();

			TestAbilityContext = XComGameStateContext_Ability(Context);
			bAbilityWasSuccess = (TestAbilityContext != none) && class'XComGameStateContext_Ability'.static.IsHitResultHit(TestAbilityContext.ResultContext.HitResult);

			if( bAbilityWasSuccess &&
				TestAbilityContext.InputContext.AbilityTemplateName == 'RiposteShot' &&
				TestAbilityContext.InputContext.SourceObject.ObjectID == AbilityContext.InputContext.SourceObject.ObjectID &&
				TestAbilityContext.InputContext.PrimaryTarget.ObjectID == AbilityContext.InputContext.PrimaryTarget.ObjectID )
			{
				// The Melee Impairing Ability has been found with the same source and target
				// Move that ability's visualization forward to this track
				AbilityTemplate = class'XComGameState_Ability'.static.GetMyTemplateManager().FindAbilityTemplate(TestAbilityContext.InputContext.AbilityTemplateName);

				for( j = 0; j < AbilityTemplate.AbilityTargetEffects.Length; ++j )
				{
					AbilityTemplate.AbilityTargetEffects[j].AddX2ActionsForVisualization(Context.AssociatedState, BuildTrack, TestAbilityContext.FindTargetEffectApplyResult(AbilityTemplate.AbilityTargetEffects[j]));
				}

				TargetVisualizerInterface = X2VisualizerInterface(BuildTrack.TrackActor);
				if (TargetVisualizerInterface != none)
				{
					TargetVisualizerInterface.BuildAbilityEffectsVisualization(Context.AssociatedState, BuildTrack);
				}
			}
		}
	}
}

simulated function Riposte_BuildVisualization(XComGameState VisualizeGameState, out array<VisualizationTrack> OutVisualizationTracks)
{
	local XComGameStateHistory History;
	local XComGameStateContext_Ability  Context;
	local StateObjectReference          InteractingUnitRef;
	local X2AbilityTemplate             AbilityTemplate;
	local XComGameState_Unit            UnitState;

	local VisualizationTrack        EmptyTrack;
	local VisualizationTrack        BuildTrack;

	local X2Action_PlaySoundAndFlyOver SoundAndFlyOver;

	History = `XCOMHISTORY;

	Context = XComGameStateContext_Ability(VisualizeGameState.GetContext());
	InteractingUnitRef = Context.InputContext.SourceObject;

	//Configure the visualization track for the shooter
	//****************************************************************************************	
	BuildTrack = EmptyTrack;
	BuildTrack.StateObject_OldState = History.GetGameStateForObjectID(InteractingUnitRef.ObjectID, eReturnType_Reference, VisualizeGameState.HistoryIndex - 1);
	BuildTrack.StateObject_NewState = VisualizeGameState.GetGameStateForObjectID(InteractingUnitRef.ObjectID);
	BuildTrack.TrackActor = History.GetVisualizer(InteractingUnitRef.ObjectID);

	UnitState = XComGameState_Unit(BuildTrack.StateObject_NewState);
	
	//Civilians on the neutral team are not allowed to have sound + flyover for hunker down
	if( UnitState.GetTeam() != eTeam_Neutral )
	{
		
		SoundAndFlyOver = X2Action_PlaySoundAndFlyOver(class'X2Action_PlaySoundAndFlyOver'.static.AddToVisualizationTrack(BuildTrack, Context));
		if (UnitState.HasSoldierAbility('SharpshooterAim'))
		{
			AbilityTemplate = class'X2AbilityTemplateManager'.static.GetAbilityTemplateManager().FindAbilityTemplate('SharpshooterAim');
		}
		else if (UnitState.HasSoldierAbility('DeepCover') && XComGameState_Unit(BuildTrack.StateObject_OldState).ActionPoints.Find(class'X2CharacterTemplateManager'.default.DeepCoverActionPoint) != INDEX_NONE)
		{
			AbilityTemplate = class'X2AbilityTemplateManager'.static.GetAbilityTemplateManager().FindAbilityTemplate('DeepCover');
		}
		else
		{
			AbilityTemplate = class'X2AbilityTemplateManager'.static.GetAbilityTemplateManager().FindAbilityTemplate(Context.InputContext.AbilityTemplateName);
		}
		SoundAndFlyOver.SetSoundAndFlyOverParameters(SoundCue'SoundUI.HunkerDownCue', AbilityTemplate.LocFlyOverText, 'HunkerDown', eColor_Good, AbilityTemplate.IconImage);
		OutVisualizationTracks.AddItem(BuildTrack);
	}
	//****************************************************************************************
}


//Staggering Shot Code

//static function X2AbilityTemplate IsmsRiposte2()
//{
	//local X2AbilityTemplate                 Template;
	//local X2AbilityCost_Ammo                AmmoCost;
	//local X2AbilityCost_ActionPoints        ActionPointCost;
	//local X2Effect_Stunned					StaggeredEffect;
	//local array<name>                       SkipExclusions;
	//local X2AbilityToHitCalc_StandardAim    StandardAim;
	//local X2AbilityCooldown                 Cooldown;
	//local X2Condition_UnitStatCheck			UnitStatCheckCondition;
//
	 //
//
	//`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsRiposte2');
	//
////Template.AdditionalAbilities.AddItem('StaggeringShotDamage');
//
	//// Icon Properties
	//Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_bulletshred";
	//Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_LIEUTENANT_PRIORITY;
	//Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	//Template.AbilitySourceName = 'eAbilitySource_Perk';
	//Template.DisplayTargetHitChance = true;
	//Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";
//
 	//Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);
//
 	//SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	//Template.AddShooterEffectExclusions(SkipExclusions);
//
 	//Template.AbilityTargetConditions.AddItem(default.GameplayVisibilityCondition);
 	//Template.AbilityTargetConditions.AddItem(default.LivingHostileTargetProperty);
 	//Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
 	//Template.AbilityTargetStyle = default.SimpleSingleTarget;
//
 	//ActionPointCost = new class'X2AbilityCost_ActionPoints';
	//ActionPointCost.iNumPoints = 1;
	//ActionPointCost.bConsumeAllPoints = true;
	//Template.AbilityCosts.AddItem(ActionPointCost);
//
 	//AmmoCost = new class'X2AbilityCost_Ammo';	
	//AmmoCost.iAmmo = 0;
	//Template.AbilityCosts.AddItem(AmmoCost);
	//Template.bAllowAmmoEffects = true;
//
 	//Cooldown = new class'X2AbilityCooldown';
	//Cooldown.iNumTurns = 1;
	//Template.AbilityCooldown = Cooldown;
//
 	//Template.bAllowFreeFireWeaponUpgrade = true; 
//
 	//Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	//Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());
//
 	//StandardAim = new class'X2AbilityToHitCalc_StandardAim';
////	StandardAim.BuiltInHitMod = 1;
	//StandardAim.bAllowCrit = true;
	//Template.AbilityToHitCalc = StandardAim;
	//Template.AbilityToHitOwnerOnMissCalc = StandardAim;
		//
 	//Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
	//Template.bUsesFiringCamera = true;
	//Template.CinescriptCameraType = "StandardGunFiring";
	//
	//StaggeredEffect = new class'X2Effect_Stunned';
	//StaggeredEffect.EffectName = 'Parried';
	//StaggeredEffect.DuplicateResponse = eDupe_Refresh; // Refresh the duration of this debuff if it's already active
	//StaggeredEffect.BuildPersistentEffect(4,,, true, eGameRule_PlayerTurnBegin);
	////StaggeredEffect.SetDisplayInfo(ePerkBuff_Penalty, default.StaggeredFriendlyName, default.StaggeredFriendlyDesc, "img:///UILibrary_PerkIcons.UIPerk_disoriented");
////	StaggeredEffect.AddPersistentStatChange(eStat_Dodge, default.StaggeringShotDodgeReduction);
////	StaggeredEffect.VisualizationFn = static.StaggeredVisualization;
////	StaggeredEffect.EffectTickedVisualizationFn = static.StaggeredVisualizationTicked;
////	StaggeredEffect.EffectRemovedVisualizationFn = static.StaggeredVisualizationRemoved;
	//StaggeredEffect.EffectHierarchyValue = class'X2StatusEffects'.default.DISORIENTED_HIERARCHY_VALUE;
	//StaggeredEffect.bRemoveWhenTargetDies = true;
	//StaggeredEffect.bIsImpairingMomentarily = true;
	//Template.AddTargetEffect(StaggeredEffect);
//
	//UnitStatCheckCondition = new class'X2Condition_UnitStatCheck';
	//UnitStatCheckCondition.AddCheckStat(eStat_will, 100, eCheck_LessThan);
	//Template.AbilityTargetConditions.AddItem(UnitStatCheckCondition);
//
	////UnitEffectsCondition = new class'X2Condition_UnitEffects';
	////UnitEffectsCondition.AddExcludeEffect(class'X2StatusEffects'.default.BleedingOutName, 'AA_UnitIsImpaired');
	////Template.AbilityTargetConditions.AddItem(UnitEffectsCondition);
//
//
	//
	//// MAKE IT LIVE!
	//Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
//
	//return Template;	
//}

static function X2AbilityTemplate RogueUnderCover()
{

//
//
//				SOME OF THIS CODE WAS BORROWED FROM -bg-'s JUGGERNAUT CLASS'S CODE
//
//

	local X2AbilityTemplate						Template;
	local X2AbilityTargetStyle                  TargetStyle;
	local X2AbilityTrigger						Trigger;
	local X2Effect_RogueCloseRangeArmor			UnderCoverArmor;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'RogueUnderCover');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_LeadByExample";

	Template.AdditionalAbilities.AddItem('IsmsSelfSufficient2Trigger');
	Template.AdditionalAbilities.AddItem('IsmsSelfSufficient3Trigger');
	Template.AdditionalAbilities.AddItem('IsmsSelfSufficient4Trigger');
	Template.AdditionalAbilities.AddItem('IsmsSelfSufficient5Trigger');
	Template.AdditionalAbilities.AddItem('IsmsSelfSufficientWill');


	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);

	UnderCoverArmor = new class'X2Effect_RogueCloseRangeArmor';
	//UnderCoverArmor.DAMAGE_REDUCTION = 0.5;
	UnderCoverArmor.RANGE = 20;  // 4 units per tile
	UnderCoverArmor.BuildPersistentEffect(1, true, false, false);
//	UnderCoverArmor.SetDisplayInfo(ePerkBuff_Passive, "Under Cover", 
//		"Reduces accuracy by" @ int(20) $ "% for enemy sources within" @ int(sqrt(24)) @ "tiles", Template.IconImage, true);
	UnderCoverArmor.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);

	Template.AddTargetEffect(UnderCoverArmor);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!

	Template.bCrossClassEligible = true;

	return Template;
}



//xylthixlm - Today at 12:18 AM
//NewGameState = class'XComGameStateContext_ChangeContainer'.static.CreateChangeState(string(GetFuncName()));
//
        //SourceUnit.GetUnitValue(default.FocusValueName, CountUnitValue);
//
        //SourceUnit = XComGameState_Unit(NewGameState.CreateStateObject(SourceUnit.Class, SourceUnit.ObjectID));
        //SourceUnit.SetUnitFloatValue(default.FocusValueName, CountUnitValue.fValue + 1, eCleanup_BeginTurn);
        //NewGameState.AddStateObject(SourceUnit);
//
        //`TACTICALRULES.SubmitGameState(NewGameState);

//XComGameState_Effect.iStacks


//Soul Collector

//Grimy effect strafe point to check for abil used
//if target = enemy, _, maybe?

 
//static function X2AbilityTemplate IsmsBattleRush()
//{
	//local X2AbilityTemplate						Template;
//// 	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;
	//local X2Effect_Persistent				BattleRushEffect; 
	////local X2Effect_Isms_SoulCollector				TrackerEffect;
//
	//`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsBattleRush');
//
	//Template.AbilitySourceName = 'eAbilitySource_Perk';
	//Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_AlwaysShow;
	//Template.Hostility = eHostility_Neutral;
	//Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_secondaryheart";
//
	//Template.AbilityToHitCalc = default.DeadEye;
	//Template.AbilityTargetStyle = default.SelfTarget;
	//Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);
//
	//
	//BattleRushEffect = class'X2Effect_Isms_SoulCollector'.static.CreateBattleRushEffect();
	//Template.AddTargetEffect(BattleRushEffect); //BMU - changing to an immediate execution for evaluation
//
 	////TrackerEffect = new class'X2Effect_Isms_SoulCollector';
	////TrackerEffect.EffectName = 'Isms_SoulCollector';
	////TrackerEffect.BuildPersistentEffect(1, true, false);
	////TrackerEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	////TrackerEffect.DuplicateResponse = eDupe_ignore; //refresh instead?
	////Template.AddShooterEffect(TrackerEffect);
//
////
	////PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	////PersistentStatChangeEffect.AddPersistentStatChange(eStat_Will, 5);
	////PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, "Self-Sufficient", "The Rogue can remove Burning, Poison, Acid, or Marked conditions if no ability has been used this turn", Template.IconImage,,,Template.AbilitySourceName);
	////Template.AddTargetEffect(PersistentStatChangeEffect);
 //
	//Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	////  NOTE: No visualization on purpose!
//
//
	//return Template;
//}



// Can use grantactionpoint, type = default.moveactionpoint
// only is granted if under effect and killing/hitting a flanked unit.
//"Step Out"
//flush them all may be better
//AIForceUnitToCursorLoc


//[XComGame.XGAIBehavior]
//+m_arrMoveWeightProfile=(Profile=BeagsEscalationFlush, fCoverWeight=2.5f, fDistanceWeight=10.0f, fFlankingWeight=0.0f, fEnemyVisWeight=-10.0f, fEnemyVisWeightPeak1=5.0f, fAllyVisWeight=0.2f, fRandWeight=1.0f)
//
//[XComGame.X2AIBTBehaviorTree]
//+Behaviors=(BehaviorName=FindDestination-BeagsEscalationFlush, NodeType=Action)
//+Behaviors=(BehaviorName=BeagsEscalationMoveForFlush, NodeType=Sequence, Child[0]=IsAbilityAvailable-StandardMove, Child[1]=FindDestination-BeagsEscalationFlush, Child[2]=SelectAbility-StandardMove)
//		THE ABOVE IS IN XCOMAI.INI  
//pretend you have reinforcements coming in. Bluff!!!!
//use fallback movement profile
// target selection section of AI
//avoid bound and panicked targets (AI)
//last resort targets, bind, panicked, etc.

 
static function X2AbilityTemplate IsmsBluff()
{
	local X2AbilityTemplate                 Template;
	local X2AbilityCost_Ammo                AmmoCost;
	local X2AbilityCost_ActionPoints        ActionPointCost;
	local array<name>                       SkipExclusions;
	local X2Condition_Visibility			VisibilityCondition;
	local X2AbilityToHitCalc_StandardAim    StandardAim;
	local X2Effect_GrantActionPoints		ActionPointsEffect;
	local X2Effect_RunBehaviorTree			BluffBehaviorEffect;
	local X2Effect_RunBehaviorTree			TestEffect;
	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;
	local X2AbilityMultiTarget_Radius		RadiusMultiTarget;
	
			
	//`LOG("Beags Escalation: Flush hit bonus=" @ string(default.BluffHitBonus));
	//`LOG("Beags Escalation: Flush ammo cost=" @ string(default.BluffAmmoCost));
	//`LOG("Beags Escalation: Flush damage multiplier=" @ string(default.FlushDamageMultiplier));

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsBluff');
	
	Template.AdditionalAbilities.AddItem('IsmsBluffDamage');

	// Icon Properties
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_CoverFire";
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_LIEUTENANT_PRIORITY;
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.DisplayTargetHitChance = true;
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";

	// Activated by a button press; additionally, tells the AI this is an activatable
	Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);

	// *** VALIDITY CHECKS *** //
	//  Normal effect restrictions (except disoriented)
	SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	Template.AddShooterEffectExclusions(SkipExclusions);

	// Targeting Details
	// Can only shoot visible enemies
	VisibilityCondition = new class'X2Condition_Visibility';
	VisibilityCondition.bRequireGameplayVisible = true;
	VisibilityCondition.bAllowSquadsight = true;
	Template.AbilityTargetConditions.AddItem(VisibilityCondition);
	// Can't target dead; Can't target friendlies
//	Template.AbilityTargetConditions.AddItem(default.LivingHostileTargetProperty);
	// Can't shoot while dead
	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	// Only at single targets that are in range.
//	Template.AbilityTargetStyle = default.SimpleSingleTarget;

	// Action Point
	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 1;
	ActionPointCost.bConsumeAllPoints = true;
	Template.AbilityCosts.AddItem(ActionPointCost);

	// Ammo
	AmmoCost = new class'X2AbilityCost_Ammo';	
	AmmoCost.iAmmo = 1;
	Template.AbilityCosts.AddItem(AmmoCost);
	Template.bAllowAmmoEffects = true;

	// Weapon Upgrade Compatibility
	Template.bAllowFreeFireWeaponUpgrade = true; // Flag that permits action to become 'free action' via 'Hair Trigger' or similar upgrade / effects

	// Allows this attack to work with the Holo-Targeting and Shredder perks, in case of AWC perkage
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());

	// There's some nice stuff built into the standard aim calculations, including a place to apply the aim bonus
	StandardAim = new class'X2AbilityToHitCalc_StandardAim';
	//StandardAim.BuiltInHitMod = default.FlushHitBonus;
	Template.AbilityToHitCalc = StandardAim;
		
	// Targeting Method. There's other ones that let you do grenade spheres, cones, etc. This is the standard, single-target selection
	//Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
	//Template.bUsesFiringCamera = true;
	//Template.CinescriptCameraType = "StandardGunFiring";

	// Adjustments
	//////////////////////////////////Template.TargetingMethod = class'X2TargetingMethod_TopDown';

	RadiusMultiTarget = new class'X2AbilityMultiTarget_Radius';
	//RadiusMultiTarget.bUseWeaponRadius = true;
	RadiusMultiTarget.fTargetRadius = 6;
	RadiusMultiTarget.bIgnoreBlockingCover = true; // skip the cover checks, the squad viewer will handle this once selected
	Template.AbilityMultiTargetStyle = RadiusMultiTarget;

	Template.AbilityTargetStyle = default.SelfTarget;

	// Give the enemy a move action point
	ActionPointsEffect = new class'X2Effect_GrantActionPoints';
	ActionPointsEffect.NumActionPoints = 2;
	ActionPointsEffect.PointType = class'X2CharacterTemplateManager'.default.MoveActionPoint;
	ActionPointsEffect.bApplyOnMiss = false;
	//ActionPointsEffect.TargetConditions.AddItem(new class'X2Condition_Beags_Escalation_InCover');
	Template.AddTargetEffect(ActionPointsEffect);
	
	// Make the enemy scamper
	BluffBehaviorEffect = new class'X2Effect_RunBehaviorTree';
	BluffBehaviorEffect.BehaviorTreeName = 'IsmsBluff';
	BluffBehaviorEffect.bApplyOnMiss = true;
//	FlushBehaviorEffect.TargetConditions.AddItem(new class'X2Condition_Beags_Escalation_InCover');
	Template.AddTargetEffect(BluffBehaviorEffect);
	
	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.EffectName = 'HunkerDown';
	PersistentStatChangeEffect.BuildPersistentEffect(1 /* Turns */,,,,eGameRule_PlayerTurnBegin);
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, Template.GetMyHelpText(), Template.IconImage);
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Dodge, 30);
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Defense, 30);
	PersistentStatChangeEffect.DuplicateResponse = eDupe_Refresh;
	Template.AddShooterEffect(PersistentStatChangeEffect);



	// MAKE IT LIVE!
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	
	Template.bCrossClassEligible = true;

	return Template;	
}


//static function X2AbilityTemplate IsmsLoneWolfPack()
//{
	//local X2AbilityTemplate                 Template;
	//local X2AbilityCost_Ammo                AmmoCost;
	//local X2AbilityCost_ActionPoints        ActionPointCost;
	//local array<name>                       SkipExclusions;
	//local X2Condition_Visibility			VisibilityCondition;
	//local X2AbilityToHitCalc_StandardAim    StandardAim;
	//local X2Effect_GrantActionPoints		ActionPointsEffect;
	//local X2Effect_RunBehaviorTree			BluffBehaviorEffect;
	//local X2Effect_RunBehaviorTree			TestEffect;
	//local X2Effect_PersistentStatChange     PersistentStatChangeEffect;
	//local X2AbilityMultiTarget_Radius		RadiusMultiTarget;
	//local X2Condition_UnitProperty			UnitPropertyCondition;
	//local X2AbilityTarget_Cursor			CursorTarget;
				//
	////`LOG("Beags Escalation: Flush hit bonus=" @ string(default.BluffHitBonus));
	////`LOG("Beags Escalation: Flush ammo cost=" @ string(default.BluffAmmoCost));
	////`LOG("Beags Escalation: Flush damage multiplier=" @ string(default.FlushDamageMultiplier));
//
	//`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsLoneWolfPack');
	//
////	Template.AdditionalAbilities.AddItem('IsmsBluffDamage');
//
	//// Icon Properties
	//Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_CoverFire";
	//Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_LIEUTENANT_PRIORITY;
	//Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	//Template.AbilitySourceName = 'eAbilitySource_Perk';
	//Template.DisplayTargetHitChance = true;
	//Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";
//
	//// Activated by a button press; additionally, tells the AI this is an activatable
	//Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);
//
	//// *** VALIDITY CHECKS *** //
	////  Normal effect restrictions (except disoriented)
	//SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	//Template.AddShooterEffectExclusions(SkipExclusions);
//
	//// Targeting Details
	//// Can only shoot visible enemies
	//VisibilityCondition = new class'X2Condition_Visibility';
	//VisibilityCondition.bRequireGameplayVisible = true;
	//VisibilityCondition.bAllowSquadsight = true;
	//Template.AbilityTargetConditions.AddItem(VisibilityCondition);
	//// Can't target dead; Can't target friendlies
	////Template.AbilityTargetConditions.AddItem(default.LivingHostileTargetProperty);
	//// Can't shoot while dead
	//Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	//
	//// Only at single targets that are in range.
	////Template.AbilityTargetStyle = default.SimpleSingleTarget;
//
//
	//// Action Point
	//ActionPointCost = new class'X2AbilityCost_ActionPoints';
	//ActionPointCost.iNumPoints = 1;
	//ActionPointCost.bConsumeAllPoints = true;
	//Template.AbilityCosts.AddItem(ActionPointCost);
//
	//// Ammo
	//AmmoCost = new class'X2AbilityCost_Ammo';	
	//AmmoCost.iAmmo = 1;
	//Template.AbilityCosts.AddItem(AmmoCost);
	//Template.bAllowAmmoEffects = true;
//
	//// Weapon Upgrade Compatibility
	//Template.bAllowFreeFireWeaponUpgrade = true; // Flag that permits action to become 'free action' via 'Hair Trigger' or similar upgrade / effects
//
	//// Allows this attack to work with the Holo-Targeting and Shredder perks, in case of AWC perkage
	//Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	//Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());
//
	//// There's some nice stuff built into the standard aim calculations, including a place to apply the aim bonus
	//StandardAim = new class'X2AbilityToHitCalc_StandardAim';
	////StandardAim.BuiltInHitMod = default.FlushHitBonus;
	//Template.AbilityToHitCalc = StandardAim;
		//
	//// Targeting Method. There's other ones that let you do grenade spheres, cones, etc. This is the standard, single-target selection
	////Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
	////Template.bUsesFiringCamera = true;
	////Template.CinescriptCameraType = "StandardGunFiring";
//
//
	////Template.AbilityTargetStyle = default.SelfTarget;
//
	//Template.TargetingMethod = class'X2TargetingMethod_TopDown';
	//
	//CursorTarget = new class'X2AbilityTarget_Cursor';
	//CursorTarget.bRestrictToSquadsightRange = true;
	//CursorTarget.FixedAbilityRange = 6;
	//Template.AbilityTargetStyle = CursorTarget;
//
//
	//RadiusMultiTarget = new class'X2AbilityMultiTarget_Radius';
	//RadiusMultiTarget.fTargetRadius = 6;
	//RadiusMultiTarget.bIgnoreBlockingCover = true; // skip the cover checks, the squad viewer will handle this once selected
	//RadiusMultiTarget.bExcludeSelfAsTargetIfWithinRadius = true;
	//Template.AbilityMultiTargetStyle = RadiusMultiTarget;	
//
	//UnitPropertyCondition = new class'X2Condition_UnitProperty';
	//UnitPropertyCondition.ExcludeDead = true;
	//UnitPropertyCondition.ExcludeFriendlyToSource = false;
	//UnitPropertyCondition.ExcludeHostileToSource = true;
	//UnitPropertyCondition.ExcludeCivilian = true;
	//UnitPropertyCondition.FailOnNonUnits = true;
	//UnitPropertyCondition.RequireWithinMinRange = true;
	//UnitPropertyCondition.WithinMinRange = 5;
	//UnitPropertyCondition.RequireWithinRange = true;
	//UnitPropertyCondition.WithinRange = 20;
	//Template.AbilityMultiTargetConditions.AddItem(UnitPropertyCondition);
//
	//
	//
	//// Give the enemy a move action point
	//ActionPointsEffect = new class'X2Effect_GrantActionPoints';
	//ActionPointsEffect.NumActionPoints = 2;
	//ActionPointsEffect.PointType = class'X2CharacterTemplateManager'.default.MoveActionPoint;
	//ActionPointsEffect.bApplyOnMiss = true;
	////ActionPointsEffect.TargetConditions.AddItem(new class'X2Condition_Beags_Escalation_InCover');
	//Template.AddTargetEffect(ActionPointsEffect);
	//
	//// Make the enemy scamper
	//BluffBehaviorEffect = new class'X2Effect_RunBehaviorTree';
	//BluffBehaviorEffect.BehaviorTreeName = 'IsmsBluff';
	//BluffBehaviorEffect.bApplyOnMiss = true;
////	FlushBehaviorEffect.TargetConditions.AddItem(new class'X2Condition_Beags_Escalation_InCover');
	//Template.AddTargetEffect(BluffBehaviorEffect);
	//
	//PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	//PersistentStatChangeEffect.EffectName = 'HunkerDown';
	//PersistentStatChangeEffect.BuildPersistentEffect(1 /* Turns */,,,,eGameRule_PlayerTurnBegin);
	//PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, Template.GetMyHelpText(), Template.IconImage);
	//PersistentStatChangeEffect.AddPersistentStatChange(eStat_Dodge, 30);
	//PersistentStatChangeEffect.AddPersistentStatChange(eStat_Defense, 30);
	//PersistentStatChangeEffect.DuplicateResponse = eDupe_Refresh;
	//PersistentStatChangeEffect.bApplyOnMiss = false;
	//Template.AddShooterEffect(PersistentStatChangeEffect);
//
//
//
	//// MAKE IT LIVE!
	//Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	//
	//Template.bCrossClassEligible = true;
//
	//return Template;	
//}

static function X2AbilityTemplate IsmsLoneWolfPack()
{
	local X2AbilityTemplate                 Template;
	local X2AbilityCost_Ammo                AmmoCost;
	local X2AbilityCost_ActionPoints        ActionPointCost;
	local array<name>                       SkipExclusions;
	local X2Condition_Visibility			VisibilityCondition;
	local X2AbilityToHitCalc_StandardAim    StandardAim;
	local X2Effect_GrantActionPoints		ActionPointsEffect;
	local X2Effect_RunBehaviorTree			BluffBehaviorEffect;
	local X2Effect_RunBehaviorTree			TestEffect;
	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;
	local X2AbilityMultiTarget_Radius		RadiusMultiTarget;
	local X2Condition_UnitProperty			UnitPropertyCondition;
	local X2AbilityTarget_Cursor			CursorTarget;
				
	//`LOG("Beags Escalation: Flush hit bonus=" @ string(default.BluffHitBonus));
	//`LOG("Beags Escalation: Flush ammo cost=" @ string(default.BluffAmmoCost));
	//`LOG("Beags Escalation: Flush damage multiplier=" @ string(default.FlushDamageMultiplier));

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsLoneWolfPack');
	
//	Template.AdditionalAbilities.AddItem('IsmsBluffDamage');

	// Icon Properties
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_CoverFire";
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_LIEUTENANT_PRIORITY;
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.DisplayTargetHitChance = true;
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";



	// *** VALIDITY CHECKS *** //
	//  Normal effect restrictions (except disoriented)
	SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	Template.AddShooterEffectExclusions(SkipExclusions);

	// Targeting Details
	// Can only shoot visible enemies
	VisibilityCondition = new class'X2Condition_Visibility';
	VisibilityCondition.bRequireGameplayVisible = true;
	VisibilityCondition.bAllowSquadsight = true;
	Template.AbilityTargetConditions.AddItem(VisibilityCondition);
	// Can't target dead; Can't target friendlies
	//Template.AbilityTargetConditions.AddItem(default.LivingHostileTargetProperty);
	// Can't shoot while dead
	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	



	// Action Point
	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 0;
	ActionPointCost.bConsumeAllPoints = true;
	Template.AbilityCosts.AddItem(ActionPointCost);

	// Ammo
	AmmoCost = new class'X2AbilityCost_Ammo';	
	AmmoCost.iAmmo = 0;
	Template.AbilityCosts.AddItem(AmmoCost);
	Template.bAllowAmmoEffects = true;

	// Weapon Upgrade Compatibility
	Template.bAllowFreeFireWeaponUpgrade = true; // Flag that permits action to become 'free action' via 'Hair Trigger' or similar upgrade / effects

	// Allows this attack to work with the Holo-Targeting and Shredder perks, in case of AWC perkage
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());

	// There's some nice stuff built into the standard aim calculations, including a place to apply the aim bonus
	StandardAim = new class'X2AbilityToHitCalc_StandardAim';
	//StandardAim.BuiltInHitMod = default.FlushHitBonus;
	Template.AbilityToHitCalc = StandardAim;
		
	// Targeting Method. There's other ones that let you do grenade spheres, cones, etc. This is the standard, single-target selection
	Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
	Template.bUsesFiringCamera = true;
	Template.CinescriptCameraType = "StandardGunFiring";
 

	// Activated by a button press; additionally, tells the AI this is an activatable
	Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);


 	// Only at single targets that are in range.
	Template.AbilityTargetStyle = default.SimpleSingleTarget;
 
 

	UnitPropertyCondition = new class'X2Condition_UnitProperty';
	UnitPropertyCondition.ExcludeDead = true;
	UnitPropertyCondition.ExcludeFriendlyToSource = false;
	UnitPropertyCondition.ExcludeHostileToSource = false;
	UnitPropertyCondition.ExcludeCivilian = true;
	UnitPropertyCondition.FailOnNonUnits = true;
	UnitPropertyCondition.RequireWithinMinRange = true;
	UnitPropertyCondition.WithinMinRange = 96;   //To make sure it doesn't count self
	UnitPropertyCondition.RequireWithinRange = true;
	UnitPropertyCondition.WithinRange = 480;	// Within 5 tiles (96 = 1 tile)
	Template.AbilityTargetConditions.AddItem(UnitPropertyCondition);

	
	
	// Give the enemy a move action point
	ActionPointsEffect = new class'X2Effect_GrantActionPoints';
	ActionPointsEffect.NumActionPoints = 2;
	ActionPointsEffect.PointType = class'X2CharacterTemplateManager'.default.MoveActionPoint;
	ActionPointsEffect.bApplyOnMiss = true;
	//ActionPointsEffect.TargetConditions.AddItem(new class'X2Condition_Beags_Escalation_InCover');
	Template.AddTargetEffect(ActionPointsEffect);
	
	// Make the enemy scamper
	BluffBehaviorEffect = new class'X2Effect_RunBehaviorTree';
	BluffBehaviorEffect.BehaviorTreeName = 'IsmsBluff';
	BluffBehaviorEffect.bApplyOnMiss = true;
//	FlushBehaviorEffect.TargetConditions.AddItem(new class'X2Condition_Beags_Escalation_InCover');
	Template.AddTargetEffect(BluffBehaviorEffect);
	
	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.EffectName = 'HunkerDown';
	PersistentStatChangeEffect.BuildPersistentEffect(1 /* Turns */,,,,eGameRule_PlayerTurnBegin);
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, Template.GetMyHelpText(), Template.IconImage);
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Dodge, 30);
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Defense, 30);
	PersistentStatChangeEffect.DuplicateResponse = eDupe_Refresh;
	PersistentStatChangeEffect.bApplyOnMiss = false;
	Template.AddShooterEffect(PersistentStatChangeEffect);



	// MAKE IT LIVE!
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	
	Template.bCrossClassEligible = true;

	return Template;	
}

static function X2AbilityTemplate RogueAndGunAbility()

//Simply copy regular standard move, then add an after action point.
//add effect to self. If effect is on self, unit has free skill of guaranteed standard move.?
// just do grant action point... stupid

{
	local X2AbilityTemplate                 Template;	
	local X2AbilityCost_Ammo                AmmoCost;
	local X2AbilityCost_ActionPoints        ActionPointCost;
	local array<name>                       SkipExclusions;
	local X2Effect_Knockback				KnockbackEffect;
	local X2Condition_Visibility            VisibilityCondition;
	local X2AbilityCooldown					Cooldown;
	//local x2effect_grantactionpoints		ActionPointEffect;
	//local X2Effect_RogueAndGunCooldown		cooldowneffect;
	//local X2Condition_UnitEffects			CooldownRequirement;
	local X2Effect_ImmediateAbilityActivation ImmediateMoveActivation;
	local AdditionalCooldownInfo CooldownInfo;
    local X2AbilityToHitCalc_StandardAim    StandardAim;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'RogueAndGun');
 
 	Template.AdditionalAbilities.AddItem('IsmsRogueAndGunMove');
 	Template.AdditionalAbilities.AddItem('RogueAndGun2');
	// Icon Properties
	Template.DisplayTargetHitChance = true;
	Template.AbilitySourceName = 'eAbilitySource_Perk';                                       // color of the icon
 	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_quadricepshypertrophy";
  
	  
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_SQUADDIE_PRIORITY;
//	Template.Hostility = eHostility_Neutral;
//	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	Template.AbilityConfirmSound = "TacticalUI_Activate_Ability_Run_N_Gun";
 

	Cooldown = new class'X2AbilityCooldown';
	Cooldown.iNumTurns = 2;
	CooldownInfo.AbilityName = 'IsmsRogueAndGunCooldown';
	CooldownInfo.NumTurns = 2;
	Cooldown.AditionalAbilityCooldowns.AddItem(CooldownInfo);
	Template.AbilityCooldown = Cooldown;

	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 1;
	ActionPointCost.bConsumeAllPoints = true;   //Here
	ActionPointCost.bFreeCost = false;
	//ActionPointCost.DoNotConsumeAllEffects.Length = 0;
//	ActionPointCost.DoNotConsumeAllSoldierAbilities.Length = 0;
	//ActionPointCost.AllowedTypes = "standard";
	Template.AbilityCosts.AddItem(ActionPointCost);

	AmmoCost = new class'X2AbilityCost_Ammo';	
	AmmoCost.iAmmo = 1;
	Template.AbilityCosts.AddItem(AmmoCost);
	Template.bAllowAmmoEffects = true; // 	
	Template.bAllowBonusWeaponEffects = true;

	Template.bAllowFreeFireWeaponUpgrade = true;                        // Flag that permits action to become 'free action' via 'Hair Trigger' or similar upgrade / effects

	//  Put holo target effect first because if the target dies from this shot, it will be too late to notify the effect.
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	//  Various Soldier ability specific effects - effects check for the ability before applying	
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());

	Template.AddTargetEffect(default.WeaponUpgradeMissDamage);

    StandardAim = new class'X2AbilityToHitCalc_StandardAim';
    StandardAim.bReactionFire = false;              // aim is here. this is causing the camera to disappear
    StandardAim.bAllowCrit = true; 
    StandardAim.bGuaranteedHit = false;    
    StandardAim.bHitsAreCrits = false;      // change this if you want all hits to be crits            
    Template.AbilityToHitCalc = StandardAim;  

	//Template.AbilityToHitOwnerOnMissCalc = default.SimpleStandardAim;

	Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
	Template.bUsesFiringCamera = true;
	Template.CinescriptCameraType = "StandardGunFiring";	

	Template.AbilityTargetStyle = default.SimpleSingleTarget;

	SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	SkipExclusions.AddItem(class'X2StatusEffects'.default.BurningName);
	Template.AddShooterEffectExclusions(SkipExclusions);

	// Targeting Details
	// Can only shoot visible enemies
	VisibilityCondition = new class'X2Condition_Visibility';
	VisibilityCondition.bRequireGameplayVisible = true;
	VisibilityCondition.bAllowSquadsight = true;
	Template.AbilityTargetConditions.AddItem(VisibilityCondition);
 	Template.AbilityTargetConditions.AddItem(default.LivingHostileTargetProperty);
	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
 
	// MAKE IT LIVE!
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;	
	Template.BuildInterruptGameStateFn = TypicalAbility_BuildInterruptGameState;

	Template.bDisplayInUITooltip = false;
	Template.bDisplayInUITacticalText = false;

	KnockbackEffect = new class'X2Effect_Knockback';
	KnockbackEffect.KnockbackDistance = 2;
	KnockbackEffect.bUseTargetLocation = true;
	Template.AddTargetEffect(KnockbackEffect);

	//ActionPointEffect = new class'x2effect_grantactionpoints';
	//actionpointeffect.numactionpoints = 1;
	//ActionPointEffect.PointType = class'X2CharacterTemplateManager'.default.MoveActionPoint;
	//ActionPointEffect.bApplyOnMiss = true;
	//template.addShootereffect(actionpointeffect);

	ImmediateMoveActivation = new class 'X2Effect_ImmediateAbilityActivation';
	ImmediateMoveActivation.BuildPersistentEffect(1, false, true, , eGameRule_PlayerTurnBegin);
	ImmediateMoveActivation.EffectName = 'IsmsRogueAndGunMove';
	ImmediateMoveActivation.AbilityName = 'IsmsRogueAndGunMove';
	ImmediateMoveActivation.bApplyOnMiss = true;	
	Template.AddShooterEffect(ImmediateMoveActivation);

 
	Template.ActivationSpeech = 'RunAndGun';
		
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;

	Template.bCrossClassEligible = true;

	return Template;
}
 
static function X2AbilityTemplate IsmsRogueAndGunMove()
{
	local X2AbilityTemplate						Template;
	local x2effect_grantactionpoints		ActionPointEffect;


	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsRogueAndGunMove');



	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
//	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_secondaryheart";
	Template.IconImage = "img:///UILibrary_Rogue.wolf_working";

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
 	Template.AbilityTriggers.AddItem(new class'X2AbilityTrigger_Placeholder');
	
	ActionPointEffect = new class'x2effect_grantactionpoints';
	actionpointeffect.numactionpoints = 1;
	ActionPointEffect.PointType = class'X2CharacterTemplateManager'.default.MoveActionPoint;
	ActionPointEffect.bApplyOnMiss = true;
	template.addShootereffect(actionpointeffect);
 
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!


	return Template;
}
