class X2Ability_Rogue3AbilitySet extends X2Ability_SharpshooterAbilitySet
	dependson (XComGameStateContext_Ability) config(RogueAbilities);

	static function array<X2DataTemplate> CreateTemplates()
{
	local array<X2DataTemplate> Templates;
 
	
	Templates.AddItem(IsmsSoulCollectorB());
	Templates.AddItem(IsmsSoulCollectorB2());	
	Templates.AddItem(IsmsSoulCollectorB3());	
	Templates.AddItem(IsmsFragileGhost());
	//Templates.AddItem(IsmsNBKB());
	//Templates.AddItem(IsmsNBKB2());
	Templates.AddItem(IsmsLoneAura());
	Templates.AddItem(IsmsLoneWolfBonus());
	Templates.AddItem(IsmsKernEyeBonus());	
	return Templates;
}

static function X2AbilityTemplate IsmsSoulCollectorB()
{
	local X2AbilityTemplate								Template;
	local X2AbilityTargetStyle							TargetStyle;
	local X2AbilityTrigger								Trigger;
	local X2Effect_RemoveEffects						RemoveEffects;
	local X2Effect_ImmediateAbilityActivation ImpairingAbilityEffect;
	local X2AbilityCharges							       Charges;
	local X2AbilityCost_ActionPoints					 ActionPointCost;
	local X2AbilityCooldown								Cooldown;
	
	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsSoulCollectorB');

	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;	
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_Adrenaline";
	Template.Hostility = eHostility_Neutral;
	Template.AbilityConfirmSound = "TacticalUI_Activate_Ability_Wraith_Armor";
	Template.AbilitySourceName = 'eAbilitySource_Psionic';

	Template.AbilityToHitCalc = default.DeadEye;
	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;
	
 	Trigger = new class'X2AbilityTrigger_PlayerInput';
	Template.AbilityTriggers.AddItem(Trigger);

 	Template.AbilityCosts.AddItem(new class'X2AbilityCost_Charges');
 	Charges = new class'X2AbilityCharges';
	Charges.InitialCharges = 1; 
	Template.AbilityCharges = Charges;

    Cooldown = new class'X2AbilityCooldown';
    Cooldown.iNumTurns = 5;
    Template.AbilityCooldown = Cooldown;

	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 1;
	ActionPointCost.bConsumeAllPoints = false;
	Template.AbilityCosts.AddItem(ActionPointCost);

	RemoveEffects = new class'X2Effect_RemoveEffects';
	RemoveEffects.EffectNamesToRemove.AddItem('Isms_SoulCollectorB');
	RemoveEffects.EffectNamesToRemove.AddItem('RushOfBattleMax');
	RemoveEffects.bcleanse = false;  //if false = heal, if true = no heal.
 	Template.AddTargetEffect(RemoveEffects);

	ImpairingAbilityEffect = new class 'X2Effect_ImmediateAbilityActivation';
	ImpairingAbilityEffect.BuildPersistentEffect(1, false, true, , eGameRule_PlayerTurnBegin);
	ImpairingAbilityEffect.EffectName = 'IsmsSoulCollectorB2';
	ImpairingAbilityEffect.AbilityName = 'IsmsSoulCollectorB2';
	ImpairingAbilityEffect.bRemoveWhenTargetDies = true;
	Template.AddTargetEffect(ImpairingAbilityEffect);

 	Template.bShowActivation = true;
	//Template.CustomFireAnim = 'HL_Psi_SelfCast';
	Template.ActivationSpeech = 'CombatStim';
	//Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	Template.CinescriptCameraType = "Psionic_FireAtUnit";
	//Template.AdditionalAbilities.AddItem('IsmsSoulCollectorB2');
	//Template.AdditionalAbilities.AddItem('IsmsSoulCollectorB3');
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;

	return Template;
}

  
	static function X2AbilityTemplate IsmsSoulCollectorB2()
{
	local X2AbilityTemplate								Template;
	local X2AbilityTargetStyle							TargetStyle;
	local X2Effect_Isms_SoulCollectorB				TrackerEffect;
	local X2Effect_PersistentStatChange         PersistentStatChangeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsSoulCollectorB2');
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;	
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_executioner";
	Template.Hostility = eHostility_Neutral;
	Template.AbilitySourceName = 'eAbilitySource_Perk';

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;
	
	Template.AbilityTriggers.AddItem(new class'X2AbilityTrigger_Placeholder');
 
 	TrackerEffect = new class'X2Effect_Isms_SoulCollectorB';
	TrackerEffect.EffectName = 'Isms_SoulCollectorB';
	TrackerEffect.BuildPersistentEffect(1, true, true, false, eGameRule_PlayerTurnBegin);
//	TrackerEffect.SetDisplayInfo(ePerkBuff_Perk, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	TrackerEffect.DuplicateResponse = eDupe_ignore;
	Template.AddTargetEffect(TrackerEffect);

  	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.EffectName = 'RushofBattleMaxDodge';
// 	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Dodge, 30);
	PersistentStatChangeEffect.DuplicateREsponse = eDupe_Refresh;
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, "Build up adrenaline whenever an enemy dies (1 point for kills, 1/3 for assists, max 6). Each point of adrenaline adds 5 dodge.", Template.IconImage, true,,Template.AbilitySourceName);
	Template.AddTargetEffect(PersistentStatChangeEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	return Template;
}

static function X2AbilityTemplate IsmsSoulCollectorB3()
{
	local X2AbilityTemplate								Template;
	local X2AbilityTargetStyle							TargetStyle;
	local X2AbilityTrigger								Trigger;
	local X2Effect_Isms_SoulCollectorB				TrackerEffect;
	local X2Condition_PlayerTurns					    TurnsCondition;
	local X2Effect_PersistentStatChange         PersistentStatChangeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsSoulCollectorB3');
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;	
 	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_Adrenaline";
 

	Template.Hostility = eHostility_Neutral;
	Template.AbilitySourceName = 'eAbilitySource_Perk';

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;
	

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);
 

	TurnsCondition = new class'X2Condition_PlayerTurns';
	TurnsCondition.NumTurnsCheck.CheckType = eCheck_LessThan;
	TurnsCondition.NumTurnsCheck.Value = 2;
	TrackerEffect.TargetConditions.AddItem(TurnsCondition);
 
 	TrackerEffect = new class'X2Effect_Isms_SoulCollectorB';
	TrackerEffect.EffectName = 'Isms_SoulCollectorB';
	TrackerEffect.BuildPersistentEffect(1, true, true, false, eGameRule_PlayerTurnBegin);
	TrackerEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, "Build up adrenaline whenever an enemy dies (1 point for kills, 1/3 for assists, max 6). Each point of adrenaline adds 5 dodge.", Template.IconImage,,,Template.AbilitySourceName);
	TrackerEffect.DuplicateResponse = eDupe_Ignore;
	Template.AddTargetEffect(TrackerEffect);

  	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.EffectName = 'RushofBattleMaxDodge';
 	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Dodge, 30);
	PersistentStatChangeEffect.DuplicateREsponse = eDupe_Refresh;
//	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, "Firstt", Template.GetMyLongDescription(), Template.IconImage, true,,Template.AbilitySourceName);
	Template.AddTargetEffect(PersistentStatChangeEffect);

	Template.AdditionalAbilities.AddItem('IsmsSoulCollectorB2');
	Template.AdditionalAbilities.AddItem('IsmsSoulCollectorB');
	//Template.AdditionalAbilities.AddItem('IsmsNBKB');
	//Template.AdditionalAbilities.AddItem('IsmsNBKB2');
	//Template.AdditionalAbilities.AddItem('IsmsNBKB3');
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	return Template;
}

 //static function X2AbilityTemplate IsmsNBKB()
//{
	//local X2AbilityTemplate								Template;
////	local X2AbilityTargetStyle							TargetStyle;
	//local X2AbilityTrigger								Trigger;
	//local X2AbilityToHitCalc_StandardAim    ToHitCalc;
	//local X2Effect_RemoveEffects						RemoveEffects;
	//local X2Effect_ImmediateAbilityActivation ImpairingAbilityEffect;
	//local X2AbilityCharges                      Charges;
	//local X2AbilityCost_ActionPoints    ActionPointCost;
	//local X2Condition_Visibility            TargetVisibilityCondition;
	//local X2Condition_UnitProperty          ShooterCondition;	 //here
	//local X2AbilityCost_Ammo                AmmoCost;
//
 //
	//`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsNBKB');
	//Template.AdditionalAbilities.AddItem('IsmsNBKB2');
	//Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;	
	//Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_executioner";
	//Template.Hostility = eHostility_Neutral;
	//Template.AbilityConfirmSound = "TacticalUI_Activate_Ability_Wraith_Armor";
	//Template.AbilitySourceName = 'eAbilitySource_Psionic';
//
	//ToHitCalc = new class'X2AbilityToHitCalc_StandardAim';
	//Template.AbilityToHitCalc = ToHitCalc;
//
//
	//Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
	//Template.bUsesFiringCamera = true;
	//Template.CinescriptCameraType = "StandardGunFiring";
//
	//AmmoCost = new class'X2AbilityCost_Ammo';
	//AmmoCost.iAmmo = 1;
	//Template.AbilityCosts.AddItem(AmmoCost);
		//
 	//Trigger = new class'X2AbilityTrigger_PlayerInput';
	//Template.AbilityTriggers.AddItem(Trigger);
//
 	//Template.AbilityCosts.AddItem(new class'X2AbilityCost_Charges');
 	//Charges = new class'X2AbilityCharges';
	//Charges.InitialCharges = 1; 
	//Template.AbilityCharges = Charges;
//
	//ActionPointCost = new class'X2AbilityCost_ActionPoints';
	//ActionPointCost.iNumPoints = 1;
	//ActionPointCost.bConsumeAllPoints = false;
	//Template.AbilityCosts.AddItem(ActionPointCost);
//
	//Template.AbilityTargetStyle = default.SimpleSingleTarget;
	//Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);
//
	//Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);	
	//ShooterCondition = new class'X2Condition_UnitProperty';
	////ShooterCondition.IsUnspotted = true;  //fix this here needs to only be activateable while concealed.
	//Template.AbilityShooterConditions.AddItem(ShooterCondition);
//
	//TargetVisibilityCondition = new class'X2Condition_Visibility';
	//TargetVisibilityCondition.bRequireGameplayVisible = true;
	//TargetVisibilityCondition.bAllowSquadsight = true;
	//Template.AbilityTargetConditions.AddItem(TargetVisibilityCondition);
	//Template.AbilityTargetConditions.AddItem(default.LivingHostileTargetProperty);
//
	//Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	//Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());
//
	//Template.bAllowAmmoEffects = true;
	//
	//
	//
	//RemoveEffects = new class'X2Effect_RemoveEffects';
	//RemoveEffects.EffectNamesToRemove.AddItem('Isms_SoulCollectorB');
	//RemoveEffects.bcleanse = true;  //if false = heal, if true = no heal.
 	//Template.AddShooterEffect(RemoveEffects);
//
	//ImpairingAbilityEffect = new class 'X2Effect_ImmediateAbilityActivation';
	//ImpairingAbilityEffect.BuildPersistentEffect(1, false, true, , eGameRule_PlayerTurnBegin);
	//ImpairingAbilityEffect.EffectName = 'IsmsNBKB2';
	//ImpairingAbilityEffect.AbilityName = 'IsmsNBKB2';
	//ImpairingAbilityEffect.bRemoveWhenTargetDies = true;
	//Template.AddShooterEffect(ImpairingAbilityEffect);
//
 	//Template.bShowActivation = true;
	////Template.CustomFireAnim = 'HL_Psi_SelfCast';
	//Template.ActivationSpeech = 'CombatStim';
	////Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	//Template.CinescriptCameraType = "StandardGunFiring";
	////Template.AdditionalAbilities.AddItem('IsmsSoulCollectorB2');
	////Template.AdditionalAbilities.AddItem('IsmsSoulCollectorB3');
	//Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
//
	//return Template;
//}
//
  //
	//static function X2AbilityTemplate IsmsNBKB2()
//{
	//local X2AbilityTemplate								Template;
	//local X2AbilityTargetStyle							TargetStyle;
	//local X2Effect_Isms_SoulCollectorB				TrackerEffect;
	//local X2Effect_PersistentStatChange         PersistentStatChangeEffect;
//
//
	//`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsNBKB2');
	//Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;	
	//Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_executioner";
	//Template.Hostility = eHostility_Neutral;
	//
	//Template.AbilityToHitCalc = default.DeadEye;
//
	//TargetStyle = new class'X2AbilityTarget_Self';
	//Template.AbilityTargetStyle = TargetStyle;
	//
	//Template.AbilityTriggers.AddItem(new class'X2AbilityTrigger_Placeholder');
  //
 	//TrackerEffect = new class'X2Effect_Isms_SoulCollectorB';
	//TrackerEffect.EffectName = 'Isms_SoulCollectorB';
	//TrackerEffect.bCanTickEveryAction = true;
	//TrackerEffect.BuildPersistentEffect(1, true, false);
	//TrackerEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	//TrackerEffect.DuplicateResponse = eDupe_ignore; //refresh instead?
	//Template.AddShooterEffect(TrackerEffect);
 //
  	//PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	//PersistentStatChangeEffect.EffectName = 'RushofBattle';
 	//PersistentStatChangeEffect.AddPersistentStatChange(eStat_Dodge, 30);
	//PersistentStatChangeEffect.DuplicateREsponse = eDupe_Refresh;
	//Template.AddTargetEffect(PersistentStatChangeEffect);
//
//
	//Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//return Template;
//}
 
 

static function X2AbilityTemplate IsmsFragileGhost()
{
	local X2AbilityTemplate						Template;
	local X2Effect_IsmsFragileGhost        DamageModifier;
//	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsFragileGhost');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_Ghost";
	

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);
	
	//PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	//PersistentStatChangeEffect.AddPersistentStatChange(eStat_Mobility, 0);
	//Template.AddTargetEffect(PersistentStatChangeEffect);

	DamageModifier = new class'X2Effect_IsmsFragileGhost';
	DamageModifier.BuildPersistentEffect(1, true, true, true);
	DamageModifier.SetDisplayInfo(ePerkBuff_Passive, "Fragile", "Take 15% more damage from all sources.", Template.IconImage, true,,Template.AbilitySourceName);
	Template.AddTargetEffect(DamageModifier);

	Template.AdditionalAbilities.AddItem('Phantom');
	Template.AdditionalAbilities.AddItem('Stealth');

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!


	return Template;
}

//static function X2AbilityTemplate Solace()
//{
	//local X2AbilityTemplate             Template;
	//local X2Effect_Solace               Effect;
//
	//`CREATE_X2ABILITY_TEMPLATE(Template, 'Solace');
//
	//Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_solace";
	//Template.AbilitySourceName = 'eAbilitySource_Psionic';
	//Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	//Template.Hostility = eHostility_Neutral;
//
	//Template.AbilityToHitCalc = default.DeadEye;
	//Template.AbilityTargetStyle = default.SelfTarget;
	//Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);
	//Template.AbilityMultiTargetStyle = new class'X2AbilityMultiTarget_AllAllies';
//
	//Effect = new class'X2Effect_Solace';
	//Effect.BuildPersistentEffect(1, true, false);
	//Effect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, true,, Template.AbilitySourceName);
	//Template.AddMultiTargetEffect(Effect);
//
	//Template.AdditionalAbilities.AddItem('SolaceCleanse');
	//Template.AdditionalAbilities.AddItem('SolacePassive');
//
	//Template.bSkipFireAction = true;
	//Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
//
	//return Template;
//}

static function X2AbilityTemplate IsmsLoneAura()
{
 
 	local X2AbilityTemplate                 Template;
	local X2AbilityTrigger_EventListener    Trigger;
 // 	local X2Condition_UnitValue				ShooterCondition;	 //here
 	local X2Effect_ApplyMedikitHeal         MedikitHeal;
//	local X2Condition_UnitEffects			ShooterEffects;
	local X2Effect_PersistentStatChange		PersistentStatChangeEffect;
	local X2AbilityMultiTarget_AllAllies	MultiTargetingStyle;	
	local X2Condition_UnitProperty          HealTargetCondition;
	
			`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsLoneAura');

	Template.AdditionalAbilities.AddItem('IsmsLoneWolfBonus');

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_RogueMod.wc3";	
	
	Trigger = new class'X2AbilityTrigger_EventListener';
	Trigger.ListenerData.Deferral = ELD_OnStateSubmitted;
	Trigger.ListenerData.EventID = 'PlayerTurnEnded';
	Trigger.ListenerData.Filter = eFilter_Player;
 	Trigger.ListenerData.EventFn = class'XComGameState_Ability'.static.AbilityTriggerEventListener_Self;
	Template.AbilityTriggers.AddItem(Trigger);

 	MultiTargetingStyle = new class'X2AbilityMultiTarget_AllAllies';
	MultiTargetingStyle.bAllowSameTarget = false;
	MultiTargetingStyle.NumTargetsRequired = 1; //At least someone must need healing
	Template.AbilityMultiTargetStyle = MultiTargetingStyle;

	 
	MedikitHeal = new class'X2Effect_ApplyMedikitHeal';
	MedikitHeal.PerUseHP = 0;
	Template.AddMultiTargetEffect(MedikitHeal);	

	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.EffectName = 'Lone Wolf Penalty';
	PersistentStatChangeEffect.BuildPersistentEffect(1 /* Turns */,,,,eGameRule_PlayerTurnBegin);
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Penalty, "Not Alone", "Not Alone", Template.IconImage);
//	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Dodge, 10);
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Defense, -20);
	PersistentStatChangeEffect.DuplicateResponse = eDupe_Refresh;
	PersistentStatChangeEffect.bApplyOnMiss = false;
	Template.AddShooterEffect(PersistentStatChangeEffect);

		//Targets must need healing
	HealTargetCondition = new class'X2Condition_UnitProperty';
	HealTargetCondition.ExcludeHostileToSource = true;
	HealTargetCondition.ExcludeFriendlyToSource = false;
	HealTargetCondition.RequireSquadmates = true;
	HealTargetCondition.WithinRange = 480; //target must be within 5 tiles.
	HealTargetCondition.RequireWithinRange = true;
 	HealTargetCondition.ExcludeDead = false; //See comment below...
	Template.AbilityMultiTargetConditions.AddItem(HealTargetCondition);

// 	Template.CustomSelfFireAnim = 'FF_FireMedkitSelf';
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;		
	Template.PostActivationEvents.AddItem('ItemRecalled');
	Template.BuildVisualizationFn = NotAloneAbility_BuildVisualization;  
 	return Template;
}
 
 static function X2AbilityTemplate IsmsLoneWolfBonus()
{
	local X2AbilityTemplate						Template;
 	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsLoneWolfBonus');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_RogueMod.wc3";	


	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);
	
	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Defense, 20);
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_SightRadius, 2);
	PersistentStatChangeEffect.EffectName = 'Lone Wolf';
//	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, "Lone Wolf", "The Lone Wolf gains 20 defense going rogue. Allies within 5 tiles disable this bonus.", Template.IconImage,,,Template.AbilitySourceName);
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, false, , Template.AbilitySourceName);

	Template.AddTargetEffect(PersistentStatChangeEffect);
 
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!


	return Template;
}


simulated function NotAloneAbility_BuildVisualization(XComGameState VisualizeGameState, out array<VisualizationTrack> OutVisualizationTracks)
{
	local XComGameStateHistory History;
	local XComGameStateContext_Ability  Context;
	local StateObjectReference          InteractingUnitRef;
	local X2AbilityTemplate             AbilityTemplate;
	local XComGameState_Unit            UnitState;

	local VisualizationTrack        EmptyTrack;
	local VisualizationTrack        BuildTrack;

	local X2Action_PlaySoundAndFlyOver SoundAndFlyOver;

	History = `XCOMHISTORY;

	Context = XComGameStateContext_Ability(VisualizeGameState.GetContext());
	InteractingUnitRef = Context.InputContext.SourceObject;

	//Configure the visualization track for the shooter
	//****************************************************************************************	
	BuildTrack = EmptyTrack;
	BuildTrack.StateObject_OldState = History.GetGameStateForObjectID(InteractingUnitRef.ObjectID, eReturnType_Reference, VisualizeGameState.HistoryIndex - 1);
	BuildTrack.StateObject_NewState = VisualizeGameState.GetGameStateForObjectID(InteractingUnitRef.ObjectID);
	BuildTrack.TrackActor = History.GetVisualizer(InteractingUnitRef.ObjectID);

	UnitState = XComGameState_Unit(BuildTrack.StateObject_NewState);
	
	//Civilians on the neutral team are not allowed to have sound + flyover for hunker down
	if( UnitState.GetTeam() != eTeam_Neutral )
	{
		
		SoundAndFlyOver = X2Action_PlaySoundAndFlyOver(class'X2Action_PlaySoundAndFlyOver'.static.AddToVisualizationTrack(BuildTrack, Context));
		if (UnitState.HasSoldierAbility('SharpshooterAim'))
		{
			AbilityTemplate = class'X2AbilityTemplateManager'.static.GetAbilityTemplateManager().FindAbilityTemplate('SharpshooterAim');
		}
 
		else
		{
			AbilityTemplate = class'X2AbilityTemplateManager'.static.GetAbilityTemplateManager().FindAbilityTemplate(Context.InputContext.AbilityTemplateName);
		}
		SoundAndFlyOver.SetSoundAndFlyOverParameters(SoundCue'SoundUI.HunkerDownCue', AbilityTemplate.LocFlyOverText, 'HunkerDown', eColor_Gray, AbilityTemplate.IconImage);
		OutVisualizationTracks.AddItem(BuildTrack);
	}
	//****************************************************************************************
}

 static function X2AbilityTemplate IsmsKernEyeBonus()
{
	local X2AbilityTemplate						Template;
 	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsKernEyeBonus');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_RogueMod.wc3";	


	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);
	
	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Hacking, 40);
//	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Defense, 40);
	//PersistentStatChangeEffect.AddPersistentStatChange(eStat_SightRadius, 3);
	PersistentStatChangeEffect.EffectName = 'Kern Eye';
//	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, "Lone Wolf", "The Lone Wolf gains 20 defense going rogue. Allies within 5 tiles disable this bonus.", Template.IconImage,,,Template.AbilitySourceName);
//	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, false, , Template.AbilitySourceName);
	Template.AddTargetEffect(PersistentStatChangeEffect);
 	
	Template.SetUIStatMarkup(class'XLocalizedData'.default.TechBonusLabel, eStat_Hacking, 40, true);
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!


	return Template;
}
