class X2Ability_Rogue4AbilitySet extends X2Ability_SharpshooterAbilitySet
	dependson (XComGameStateContext_Ability) config(RogueAbilities);

static function array<X2DataTemplate> CreateTemplates()
{
	local array<X2DataTemplate> Templates;

	//Templates.AddItem(LoneWolfBonus2());
 	Templates.AddItem(IsmsNBKMobility());
 	Templates.AddItem(IsmsNBKGrandFinale());
  	Templates.AddItem(IsmsLastWish());
	Templates.AddItem(SustainTriggered3());
	Templates.AddItem(IsmsScoutPack());
	Templates.AddItem(IsmsUpside());
	Templates.AddItem(IsmsFlush());
	Templates.AddItem(IsmsFlushDamage());
	Templates.AddItem(IsmsScoutsOverwatch());
	Templates.AddItem(IsmsScoutsOverwatchShot());
	Templates.AddItem(IsmsOnTheMove());
	Templates.AddItem(IsmsRelocate());
	Templates.AddItem(IsmsRelocateStealth());
	Templates.AddItem(IsmsScoutIntel());
	Templates.AddItem(IsmsTactics());
	Templates.AddItem(IsmsIntelReset());
	Templates.AddItem(IsmsFreeScanner());
	return Templates;
}

//static function X2AbilityTemplate LoneWolfBonus2()
//{
	//local XMBEffect_PermanentStatChange Effect;
	//local X2AbilityTemplate Template;
	////local X2Condition_UnitProperty Condition;
//
	//// Create a permanent stat change effect that adds 5 to Hacking
	//Effect = new class'XMBEffect_PermanentStatChange';
	//Effect.AddStatChange(eStat_Mobility, 8);
//
	//// Create a triggered ability that activates whenever the unit gets a kill
////	Template = SelfTargetTrigger('XMBExample_ReverseEngineering', "img:///UILibrary_PerkIcons.UIPerk_command", false, Effect, 'KillMail');
	//return Passive('LoneWolfBonus2', "img:///UILibrary_PerkIcons.UIPerk_command", true, Effect);
	//// Trigger abilities don't appear as passives. Add a passive ability icon.
	//AddIconPassive(Template);
//
	////// Restrict to robotic enemies
	////Condition = new class'X2Condition_UnitProperty';
	////Condition.ExcludeOrganic = true;
	////Condition.ExcludeDead = false;
	////Condition.ExcludeFriendlyToSource = true;
	////Condition.ExcludeHostileToSource = false;
	////AddTriggerTargetCondition(Template, Condition);
//
	//return Template;
//}

//static function X2AbilityTemplate LoneWolfBonus2()
//{
	//local X2AbilityTemplate						Template;
	//local XMBEffect_PermanentStatChange Effect; 
//
	//`CREATE_X2ABILITY_TEMPLATE(Template, 'LoneWolfBonus2');
//
	//Template.AbilitySourceName = 'eAbilitySource_Perk';
	//Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	//Template.Hostility = eHostility_Neutral;
	//Template.IconImage = "img:///UILibrary_RogueMod.wc3";	
//
//
	//Template.AbilityToHitCalc = default.DeadEye;
	//Template.AbilityTargetStyle = default.SelfTarget;
	//Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);
	//
 	//Effect = new class'XMBEffect_PermanentStatChange';
	//Effect.AddStatChange(eStat_Mobility, -6);
	//Template.AddTargetEffect(Effect);
 //
//
//
 //
	//Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	////  NOTE: No visualization on purpose!
//
//
	//return Template;
//}

static function X2AbilityTemplate IsmsNBKMobility()
{
	local X2AbilityTemplate						Template;
	local X2Effect_NBKMobility Effect; 
	local X2AbilityTrigger_EventListener    Trigger;
	local X2Condition_UnitEffects			ShooterEffects;
 	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsNBKMobility');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	//Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_Executioner";
	Template.IconImage = "img:///UILibrary_Rogue2.UIPerk_move_blaze";

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	//Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);
	//Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);
 	Trigger = new class'X2AbilityTrigger_EventListener';
	Trigger.ListenerData.Deferral = ELD_OnStateSubmitted;
	Trigger.ListenerData.EventID = 'PlayerTurnEnded';
	Trigger.ListenerData.Filter = eFilter_Player;
 	Trigger.ListenerData.EventFn = class'XComGameState_Ability'.static.AbilityTriggerEventListener_Self;
	Template.AbilityTriggers.AddItem(Trigger);
 
 	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	PersistentStatChangeEffect.DuplicateResponse = eDupe_ignore;
	Template.AddTargetEffect(PersistentStatChangeEffect);
 	
	Effect = new class'X2Effect_NBKMobility';
 	Effect.AddPersistentStatChange(eStat_Mobility, 1);
	Effect.EffectName = 'Isms_NBKMobility';
	Effect.BuildPersistentEffect(6, false, false, false, eGameRule_PlayerTurnBegin);
	Effect.DuplicateResponse = eDupe_Allow;
	//Effect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	Template.AddTargetEffect(Effect);

	ShooterEffects = new class'X2Condition_UnitEffects';
 	ShooterEffects.AddExcludeEffect('Exhausted', 'AA_UnitIsNotMarked'); 
	//
 	Template.AbilityShooterConditions.AddItem(ShooterEffects);	
	Template.AdditionalAbilities.AddItem('IsmsNBKGrandFinale');
 
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!


	return Template;
}


static function X2AbilityTemplate IsmsNBKGrandFinale()
{
	local X2AbilityTemplate						Template;
 	local X2Effect_RemoveEffects						RemoveEffects;
	local X2AbilityCharges                      Charges;
    local X2AbilityCooldown				 Cooldown;
	local X2AbilityToHitCalc_StandardAim    ToHitCalc;
	local X2AbilityCost_Ammo                AmmoCost;
	local X2AbilityCost_ActionPoints    ActionPointCost;
	local X2Condition_Visibility            TargetVisibilityCondition;
	local X2Condition_UnitProperty          ShooterCondition;	 //here
	local X2Effect_NBKMobility2 Effect; 
	local X2AbilityCost_ChargesNBK			ChargeCost;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsNBKGrandFinale');

	Template.ConcealmentRule = eConceal_Never;
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_AlwaysShow;
	Template.Hostility = eHostility_Neutral;
	//Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_Executioner";
	Template.IconImage = "img:///UILibrary_Rogue2.UIPerk_rifle_blaze";	
	//Template.AdditionalAbilities.AddItem('IsmsNBKMobility');

	
	
	ToHitCalc = new class'X2AbilityToHitCalc_StandardAim';
	Template.AbilityToHitCalc = ToHitCalc;

	Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
	Template.bUsesFiringCamera = true;
	Template.CinescriptCameraType = "StandardGunFiring";

	AmmoCost = new class'X2AbilityCost_Ammo';
	AmmoCost.iAmmo = 1;
	Template.AbilityCosts.AddItem(AmmoCost);

	ChargeCost = new class'X2AbilityCost_ChargesNBK';
	ChargeCost.NumCharges = 1;
	Template.AbilityCosts.AddItem(ChargeCost);

 	Charges = new class'X2AbilityCharges';
	Charges.InitialCharges = 0; 
	Template.AbilityCharges = Charges;

    Cooldown = new class'X2AbilityCooldown';
    Cooldown.iNumTurns = 2;
    Template.AbilityCooldown = Cooldown;

	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 1;
	ActionPointCost.bConsumeAllPoints = true;
	Template.AbilityCosts.AddItem(ActionPointCost);

	Template.AbilityTargetStyle = default.SimpleSingleTarget;
	Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);
//
	//Template.AbilityToHitCalc = default.DeadEye;
	//Template.AbilityTargetStyle = default.SelfTarget;
	//Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);
	//Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);
 
 	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);	
	ShooterCondition = new class'X2Condition_UnitProperty';
	//ShooterCondition.IsUnspotted = true;  //fix this here needs to only be activateable while concealed.
	Template.AbilityShooterConditions.AddItem(ShooterCondition);

	TargetVisibilityCondition = new class'X2Condition_Visibility';
	TargetVisibilityCondition.bRequireGameplayVisible = true;
	TargetVisibilityCondition.bAllowSquadsight = true;
	Template.AbilityTargetConditions.AddItem(TargetVisibilityCondition);
	Template.AbilityTargetConditions.AddItem(default.LivingHostileTargetProperty);

	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());

	Template.bAllowAmmoEffects = true;
	

 	RemoveEffects = new class'X2Effect_RemoveEffects';
	RemoveEffects.EffectNamesToRemove.AddItem('Isms_NBKMobility');
	RemoveEffects.bApplyOnMiss = true;
 	Template.AddShooterEffect(RemoveEffects);

	Effect = new class'X2Effect_NBKMobility2';
 	//Effect.AddPersistentStatChange(eStat_Mobility, 0);
	Effect.EffectName = 'Exhausted';
	Effect.BuildPersistentEffect(2, false, false, false, eGameRule_PlayerTurnBegin);
	Effect.DuplicateResponse = eDupe_ignore;
	Effect.bApplyOnMiss = true;	
	Effect.SetDisplayInfo(ePerkBuff_Passive, "Exhausted", "Unit is exhausted and cannot gain focus.", "img:///UILibrary_Rogue2.UIPerk_stabilize_move2",,,Template.AbilitySourceName);
	Template.AddShooterEffect(Effect);
 
	Template.bShowActivation = true;
	//Template.CustomFireAnim = 'HL_Psi_SelfCast';
//	Template.ActivationSpeech = 'CombatStim';
 	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	Template.CinescriptCameraType = "StandardGunFiring";
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!


	return Template;
}

static function X2AbilityTemplate IsmsLastWish()
{
	local X2AbilityTemplate             Template;
	local X2Effect_IsmsLastWish              SustainEffect;
 	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsLastWish');

	Template.AdditionalAbilities.AddItem('SustainTriggered3');

	Template.IconImage = "img:///UILibrary_Rogue2.UIPerk_stealth_cycle";	
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.bIsPassive = true;

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);

	SustainEffect = new class'X2Effect_IsmsLastWish';
	SustainEffect.BuildPersistentEffect(1, true, true);
	SustainEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, false,,Template.AbilitySourceName);
	Template.AddTargetEffect(SustainEffect);

	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Will, 1);
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	Template.AddTargetEffect(PersistentStatChangeEffect);

//	Template.PostActivationEvents.AddItem('SustainTriggered2');
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	// Note: no visualization on purpose!

	//Template.AdditionalAbilities.AddItem('JackLastStandTriggered');
	return Template;
}

static function X2DataTemplate SustainTriggered3()
{
	local X2AbilityTemplate                 Template;
	local X2Effect_Stasis                   StasisEffect;
	local X2AbilityTrigger_EventListener    EventTrigger;
	local X2Effect_DelayedAbilityActivation DelayedPsiExplosionEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'SustainTriggered3');

	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_sustain";
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.AbilitySourceName = 'eAbilitySource_Psionic';

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;

	StasisEffect = new class'X2Effect_Stasis';
	StasisEffect.BuildPersistentEffect(2, false, false, false, eGameRule_PlayerTurnBegin);
	StasisEffect.bUseSourcePlayerState = true;
	StasisEffect.bRemoveWhenTargetDies = true;          //  probably shouldn't be possible for them to die while in stasis, but just in case
	StasisEffect.SetDisplayInfo(ePerkBuff_Penalty, Template.LocFriendlyName, Template.GetMyHelpText(), Template.IconImage);
	StasisEffect.StunStartAnim = 'HL_PsiSustainStart'; 
	StasisEffect.CustomIdleOverrideAnim = 'HL_CarryBodyLoop';
	StasisEffect.bSkipFlyover = true;
	Template.AddTargetEffect(StasisEffect);

	EventTrigger = new class'X2AbilityTrigger_EventListener';
	EventTrigger.ListenerData.Deferral = ELD_OnStateSubmitted;
	EventTrigger.ListenerData.EventID = 'SustainTriggered3';
	EventTrigger.ListenerData.Filter = eFilter_Unit;
	EventTrigger.ListenerData.EventFn = class'XComGameState_Ability'.static.AbilityTriggerEventListener_Self_VisualizeInGameState;
	Template.AbilityTriggers.AddItem(EventTrigger);

	Template.PostActivationEvents.AddItem(class'X2Effect_Sustain'.default.SustainTriggeredEvent);

	DelayedPsiExplosionEffect = new class 'X2Effect_DelayedAbilityActivation';
	DelayedPsiExplosionEffect.BuildPersistentEffect(2, false, false, , eGameRule_PlayerTurnBegin);
	DelayedPsiExplosionEffect.EffectName = 'EffectEnterUnitConcealment';
	DelayedPsiExplosionEffect.TriggerEventName = 'EffectEnterUnitConcealment';
	DelayedPsiExplosionEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, true, , Template.AbilitySourceName);
	Template.AddShooterEffect(DelayedPsiExplosionEffect);
			
	Template.ActivationSpeech = 'Deathscream';
	//Template.bSkipFireAction = true;
	//Template.bSkipFireAction = false;
	Template.CinescriptCameraType = "StandardGunFiring";
	Template.FrameAbilityCameraType = eCameraFraming_Never;
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;  //stun smooth
	//Template.BuildVisualizationFn = Knockout_BuildVisualization;  //knockout into stun idle
	//Template.BuildVisualizationFn = Knockout_BuildVisualization;


		//Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
////	Template.BuildVisualizationFn = Knockout_BuildVisualization;
	//Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;  ////blinks lay down, then goes to stun idle
////	Template.BuildAffectedVisualizationSyncFn = Knockout_BuildAffectedVisualizationSync;
////	Template.BuildVisualizationFn = StunLancerImpairing_BuildVisualization;  //blinks lay down, then goes to stun idle
 	//Template.CinescriptCameraType = "Psionic_FireAtUnit";
	return Template;
}



	static function X2AbilityTemplate IsmsScoutPack()
{
	local X2AbilityTemplate						Template;
 	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsScoutPack');

	Template.AdditionalAbilities.AddItem('IsmsUpside');
	Template.AdditionalAbilities.AddItem('IsmsFreeScanner');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_Rogue2.UIPerk_rifle_overwatch";

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);
	
	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_SightRadius, 6);
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	Template.AddTargetEffect(PersistentStatChangeEffect);
 
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!


	return Template;
}

static function X2AbilityTemplate IsmsUpside()
{
	local X2AbilityTemplate						Template;
	local X2Effect_RogueUpside        DamageModifier;
//	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsUpside');

	Template.OverrideAbilities.AddItem('HuntersInstinct2');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_hunter";

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);
	
 
	DamageModifier = new class'X2Effect_RogueUpside';

 	DamageModifier.BuildPersistentEffect(1, true, true, true);
	DamageModifier.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, true,,Template.AbilitySourceName);
 

	Template.AddTargetEffect(DamageModifier);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!


	return Template;
}


// The Following Code was borrowed from "Escalation Classes" by Divine Lubrication.

static function X2AbilityTemplate IsmsFlush()
{
	local X2AbilityTemplate                 Template;
	local X2AbilityCost_Ammo                AmmoCost;
	local X2AbilityCost_ActionPoints        ActionPointCost;
	local array<name>                       SkipExclusions;
	local X2Condition_Visibility			VisibilityCondition;
	local X2AbilityToHitCalc_StandardAim    StandardAim;
	local X2Effect_GrantActionPoints		ActionPointsEffect;
	local X2Effect_RunBehaviorTree			FlushBehaviorEffect;
	local X2AbilityCooldown					Cooldown;
  
	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsFlush');
	
	Template.AdditionalAbilities.AddItem('IsmsFlushDamage');

	// Icon Properties
	Template.IconImage = "img:///UILibrary_Rogue2.UIPerk_flush";
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_Corporal_PRIORITY;
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.DisplayTargetHitChance = true;
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";

	// Activated by a button press; additionally, tells the AI this is an activatable
	Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);

	// *** VALIDITY CHECKS *** //
	//  Normal effect restrictions (except disoriented)
	SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	Template.AddShooterEffectExclusions(SkipExclusions);

	// Targeting Details
	// Can only shoot visible enemies
	VisibilityCondition = new class'X2Condition_Visibility';
	VisibilityCondition.bRequireGameplayVisible = true;
	VisibilityCondition.bAllowSquadsight = true;
	Template.AbilityTargetConditions.AddItem(VisibilityCondition);
	// Can't target dead; Can't target friendlies
	Template.AbilityTargetConditions.AddItem(default.LivingHostileTargetProperty);
	// Can't shoot while dead
	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	// Only at single targets that are in range.
	Template.AbilityTargetStyle = default.SimpleSingleTarget;

	// Action Point
	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 1;
	ActionPointCost.bConsumeAllPoints = true;
	Template.AbilityCosts.AddItem(ActionPointCost);

	// Ammo
	AmmoCost = new class'X2AbilityCost_Ammo';	
	AmmoCost.iAmmo = 2;
	Template.AbilityCosts.AddItem(AmmoCost);
	Template.bAllowAmmoEffects = true;

    Cooldown = new class'X2AbilityCooldown';
    Cooldown.iNumTurns = 1;
    Template.AbilityCooldown = Cooldown;

	// Weapon Upgrade Compatibility
	Template.bAllowFreeFireWeaponUpgrade = true; // Flag that permits action to become 'free action' via 'Hair Trigger' or similar upgrade / effects

	// Allows this attack to work with the Holo-Targeting and Shredder perks, in case of AWC perkage
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());

	// There's some nice stuff built into the standard aim calculations, including a place to apply the aim bonus
	StandardAim = new class'X2AbilityToHitCalc_StandardAim';
	StandardAim.BuiltInHitMod = 30;
	Template.AbilityToHitCalc = StandardAim;
		
	// Targeting Method. There's other ones that let you do grenade spheres, cones, etc. This is the standard, single-target selection
	Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
	Template.bUsesFiringCamera = true;
	Template.CinescriptCameraType = "StandardGunFiring";

	// Give the enemy a move action point
	ActionPointsEffect = new class'X2Effect_GrantActionPoints';
	ActionPointsEffect.NumActionPoints = 1;
	ActionPointsEffect.PointType = class'X2CharacterTemplateManager'.default.MoveActionPoint;
	ActionPointsEffect.bApplyOnMiss = true;
 	Template.AddTargetEffect(ActionPointsEffect);
	
	// Make the enemy scamper
	FlushBehaviorEffect = new class'X2Effect_RunBehaviorTree';
	FlushBehaviorEffect.BehaviorTreeName = 'Fallback'; 
//	FlushBehaviorEffect.BehaviorTreeName = 'IsmsBluff'; //PanickedFallBackUnsafe
	FlushBehaviorEffect.bApplyOnMiss = true;
 	Template.AddTargetEffect(FlushBehaviorEffect);
	
	// MAKE IT LIVE!
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	
	Template.bCrossClassEligible = true;

	return Template;	
}
 

static function X2AbilityTemplate IsmsFlushDamage()
{
	local X2AbilityTemplate						Template;
	local X2Effect_Deadeye2Damage                DamageEffect;
 
	// Icon Properties
	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsFlushDamage');
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_momentum";

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);

	DamageEffect = new class'X2Effect_Deadeye2Damage';
 	DamageEffect.DamageMultiplier = 0.55f;		
	DamageEffect.BuildPersistentEffect(1, true, false, false);
	DamageEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, false,,Template.AbilitySourceName);
	Template.AddTargetEffect(DamageEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!

	return Template;
}

static function X2AbilityTemplate IsmsScoutsOverwatch()
{
 
    local X2AbilityTemplate				 Template;
    local X2AbilityCooldown				 Cooldown;
    local X2AbilityCost_Ammo			 AmmoCost;
    local X2AbilityCost_ActionPoints	 ActionPointCost;
    local X2AbilityTarget_Cursor		 CursorTarget;
    local X2AbilityMultiTarget_Cone		 ConeMultiTarget;
    local X2Effect_ReserveActionPoints		ReservePointsEffect;
    local X2Effect_MarkValidActivationTiles MarkTilesEffect;
    local X2Condition_UnitEffects           SuppressedCondition;
//  local X2AbilityCharges                      Charges;
 
    `CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsScoutsOverwatch');

	//Template.ConcealmentRule = eConceal_Always;
 	Template.OverrideAbilities.AddItem('Overwatch');

    AmmoCost = new class'X2AbilityCost_Ammo';
    AmmoCost.iAmmo = 1;
    AmmoCost.bFreeCost = true;
    Template.AbilityCosts.AddItem(AmmoCost);
 
    ActionPointCost = new class'X2AbilityCost_ActionPoints';
    ActionPointCost.iNumPoints = 1;
    ActionPointCost.bConsumeAllPoints = false;   //  this will guarantee the unit has at least 1 action point
    ActionPointCost.bFreeCost = true;           //  ReserveActionPoints effect will take all action points away
    Template.AbilityCosts.AddItem(ActionPointCost);
 
    Template.AbilityToHitCalc = default.DeadEye;
 
    Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
    Template.AddShooterEffectExclusions();
    SuppressedCondition = new class'X2Condition_UnitEffects';
    SuppressedCondition.AddExcludeEffect(class'X2Effect_Suppression'.default.EffectName, 'AA_UnitIsSuppressed');
    Template.AbilityShooterConditions.AddItem(SuppressedCondition);
 
    Cooldown = new class'X2AbilityCooldown';
    Cooldown.iNumTurns = 1;
    Template.AbilityCooldown = Cooldown;
 
 
    CursorTarget = new class'X2AbilityTarget_Cursor';
    CursorTarget.bRestrictToWeaponRange = false;
    Template.AbilityTargetStyle = CursorTarget;
 
    ConeMultiTarget = new class'X2AbilityMultiTarget_Cone';
    ConeMultiTarget.bUseWeaponRadius = false;
    ConeMultiTarget.ConeEndDiameter = 8* class'XComWorldData'.const.WORLD_StepSize;  //LOOK HERE
    ConeMultiTarget.ConeLength = 22 * class'XComWorldData'.const.WORLD_StepSize;		//LOOK HERE
    Template.AbilityMultiTargetStyle = ConeMultiTarget;
 
    Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);
 
    ReservePointsEffect = new class'X2Effect_ReserveActionPoints';
    ReservePointsEffect.ReserveType = 'RogueAmbush';
    ReservePointsEffect.NumPoints = 1;  //# of shots in overwatch
    Template.AddShooterEffect(ReservePointsEffect);
 
    // Call var int m_iMovePipsTouched  from dependson(XComGameState_Unit);
 
    MarkTilesEffect = new class'X2Effect_MarkValidActivationTiles';
    MarkTilesEffect.AbilityToMark = 'IsmsScoutsOverwatchShot';    //here
    Template.AddShooterEffect(MarkTilesEffect);
 
    Template.AdditionalAbilities.AddItem('IsmsScoutsOverwatchShot');  

    Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
    Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
    Template.bSkipFireAction = true;
    Template.bShowActivation = true;
 
    Template.AbilitySourceName = 'eAbilitySource_Perk';
    Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_AlwaysShow;
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_overwatch";
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.OVERWATCH_PRIORITY;
    Template.bDisplayInUITooltip = false;
    Template.bDisplayInUITacticalText = false;
    Template.Hostility = eHostility_Neutral;
    Template.AbilityConfirmSound = "Unreal2DSounds_OverWatch";
 
    Template.ActivationSpeech = 'KillZone';
 	


    Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
    Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
    Template.TargetingMethod = class'X2TargetingMethod_Cone';
 
    Template.bCrossClassEligible = false;
 
    return Template;
}
 
//     function bool AllowCritOverride() { return true; }   // test
 
static function X2AbilityTemplate IsmsScoutsOverwatchShot()
{
    local X2AbilityTemplate                 Template;
    local X2AbilityCost_Ammo                AmmoCost;
    local X2AbilityCost_ReserveActionPoints ReserveActionPointCost;
    local X2AbilityToHitCalc_StandardAim    StandardAim;
    local X2Condition_AbilityProperty       AbilityCondition;
    local X2AbilityTarget_Single            SingleTarget;
    local X2AbilityTrigger_Event            Trigger;
    local X2Effect_Persistent               KillZoneEffect;
    local X2Condition_UnitEffectsWithAbilitySource  KillZoneCondition;
    local X2Condition_Visibility            TargetVisibilityCondition;
 

    `CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsScoutsOverwatchShot');
 
// 	Template.ConcealmentRule = eConceal_Always;

    AmmoCost = new class'X2AbilityCost_Ammo';
    AmmoCost.iAmmo = 1;
    Template.AbilityCosts.AddItem(AmmoCost);
   
//    Template.AdditionalAbilities.AddItem('DeadeyeDamage');    //testing
   
    ReserveActionPointCost = new class'X2AbilityCost_ReserveActionPoints';
    ReserveActionPointCost.iNumPoints = 1;              //here?
    ReserveActionPointCost.bFreeCost = false;
    ReserveActionPointCost.AllowedTypes.AddItem('RogueAmbush');                
    Template.AbilityCosts.AddItem(ReserveActionPointCost);
 
    StandardAim = new class'X2AbilityToHitCalc_StandardAim';
    StandardAim.bReactionFire = false;              // aim is here. this is causing the camera to disappear
 // StandardAim.bAllowCrit = true; 
    StandardAim.bGuaranteedHit = false;    
    StandardAim.bHitsAreCrits = false;      // change this if you want all hits to be crits            
    Template.AbilityToHitCalc = StandardAim;                            // You can mess around above here to change the aim
	 
    Template.AbilityTargetConditions.AddItem(default.LivingHostileUnitDisallowMindControlProperty);
    TargetVisibilityCondition = new class'X2Condition_Visibility';
    TargetVisibilityCondition.bRequireGameplayVisible = true;
    TargetVisibilityCondition.bDisablePeeksOnMovement = true;
    TargetVisibilityCondition.bAllowSquadsight = true;
    Template.AbilityTargetConditions.AddItem(TargetVisibilityCondition);
    AbilityCondition = new class'X2Condition_AbilityProperty';
    AbilityCondition.TargetMustBeInValidTiles = true;
    Template.AbilityTargetConditions.AddItem(AbilityCondition);
    Template.AbilityTargetConditions.AddItem(class'X2Ability_DefaultAbilitySet'.static.OverwatchTargetEffectsCondition());
 
    Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
    Template.AddShooterEffectExclusions();
 
	//  Do not shoot targets that were already hit by this unit this turn with this ability
	KillZoneCondition = new class'X2Condition_UnitEffectsWithAbilitySource';
	KillZoneCondition.AddExcludeEffect('KillZoneTarget', 'AA_UnitIsImmune');
	Template.AbilityTargetConditions.AddItem(KillZoneCondition);
	//  Mark the target as shot by this unit so it cannot be shot again this turn
	KillZoneEffect = new class'X2Effect_Persistent';
	KillZoneEffect.EffectName = 'KillZoneTarget';
	KillZoneEffect.BuildPersistentEffect(1, false, false, false, eGameRule_PlayerTurnBegin);
	KillZoneEffect.SetupEffectOnShotContextResult(true, true);      //  mark them regardless of whether the shot hit or missed
	Template.AddTargetEffect(KillZoneEffect); 
  
    SingleTarget = new class'X2AbilityTarget_Single';
    SingleTarget.OnlyIncludeTargetsInsideWeaponRange = true;
    Template.AbilityTargetStyle = SingleTarget;
 
    //  Put holo target effect first because if the target dies from this shot, it will be too late to notify the effect.
    // holo or shredder here?
    Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
    Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());
 	Template.AssociatedPassives.AddItem('HoloTargeting');
    Template.bAllowAmmoEffects = true;
 	Template.AddTargetEffect(default.WeaponUpgradeMissDamage);

    //Trigger on movement - interrupt the move
    Trigger = new class'X2AbilityTrigger_Event';
    Trigger.EventObserverClass = class'X2TacticalGameRuleset_MovementObserver';
    Trigger.MethodName = 'InterruptGameState';
    Template.AbilityTriggers.AddItem(Trigger);

    //Trigger = new class'X2AbilityTrigger_Event';
    //Trigger.EventObserverClass = class'X2TacticalGameRuleset_AttackObserver';
    //Trigger.MethodName = 'InterruptGameState';
    //Template.AbilityTriggers.AddItem(Trigger);
 
 	Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
	Template.bUsesFiringCamera = true;
	Template.CinescriptCameraType = "StandardGunFiring"; 
    Template.AbilityConfirmSound = "Unreal2DSounds_OverWatch";

    Template.AbilitySourceName = 'eAbilitySource_Perk';
    Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
    Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_overwatch";
    Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.STANDARD_PISTOL_SHOT_PRIORITY;
    Template.bDisplayInUITooltip = false;
    Template.bDisplayInUITacticalText = false;
 
    Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
    Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
 
    return Template;
}  

static function X2AbilityTemplate IsmsOnTheMove()
{
	local X2AbilityTemplate						Template;
	local X2Effect_PersistentStatChange			PersistentStatChangeEffect; 
	local X2Effect_TurnStartActionPoints ThreeActionPoints;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsOnTheMove');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_Rogue2.UIPerk_move_command";	//UIPerk_move_command


	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);
	
	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Mobility, -6);
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	Template.AddTargetEffect(PersistentStatChangeEffect);
  
 	ThreeActionPoints = new class'X2Effect_TurnStartActionPoints';
	ThreeActionPoints.ActionPointType = class'X2CharacterTemplateManager'.default.StandardActionPoint;
	ThreeActionPoints.NumActionPoints = 1;
	ThreeActionPoints.bInfiniteDuration = true;
	Template.AddTargetEffect(ThreeActionPoints);

 
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!


	return Template;

}


// Relocate stealths all allies in the game for one turn and gives them 2 mobility action points

static function X2AbilityTemplate IsmsRelocate()
{
	local X2AbilityTemplate				Template;
	local X2AbilityCost_ActionPoints	ActionPointCost; 
	local X2Condition_UnitProperty      TargetCondition;
	local X2AbilityCooldown             Cooldown;
	local X2AbilityTarget_Cursor        CursorTarget;
	local X2AbilityMultiTarget_AllAllies	MultiTargetingStyle;	
	local X2AbilityTrigger_PlayerInput	InputTrigger;
	local X2Effect_PersistentStatChange		StatEffect;			
	local X2Effect_GrantRelocatePoints		ActionPointsEffect;
	local X2Effect_ImmediateAbilityActivation ImpairingAbilityEffect;


	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsRelocate');

	// Icon Properties
	Template.AbilitySourceName = 'eAbilitySource_Standard';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;	
	Template.IconImage = "img:///UILibrary_Rogue2.UIPerk_stealth_move2";
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_COLONEL_PRIORITY;
	Template.Hostility = eHostility_Neutral;
	Template.DisplayTargetHitChance = false;

	
	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 0;
	ActionPointCost.bConsumeAllPoints = false;
	Template.AbilityCosts.AddItem(ActionPointCost);

	Cooldown = new class'X2AbilityCooldown';
	Cooldown.iNumTurns = 10;
	Template.AbilityCooldown = Cooldown;

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;

	CursorTarget = new class'X2AbilityTarget_Cursor';
	CursorTarget.bRestrictToWeaponRange = true;
	Template.AbilityTargetStyle = CursorTarget;

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	Template.AddShooterEffectExclusions();

	Template.AbilityTargetStyle = default.SelfTarget;
	MultiTargetingStyle = new class'X2AbilityMultiTarget_AllAllies';
	MultiTargetingStyle.bAllowSameTarget = true;
	Template.AbilityMultiTargetStyle = MultiTargetingStyle;

	InputTrigger = new class'X2AbilityTrigger_PlayerInput';
	Template.AbilityTriggers.AddItem(InputTrigger);

	TargetCondition = new class'X2Condition_UnitProperty';
	TargetCondition.ExcludeAlive = false;
	TargetCondition.ExcludeHostileToSource = true;
	TargetCondition.ExcludeFriendlyToSource = false;
	TargetCondition.RequireSquadmates = true;
	TargetCondition.FailOnNonUnits = true;
	TargetCondition.ExcludeDead = true;
	Template.AbilityMultiTargetConditions.AddItem(TargetCondition);

	StatEffect = new class'X2Effect_PersistentStatChange';
	StatEffect.DuplicateResponse = eDupe_Ignore;
	StatEffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	StatEffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, Template.GetMyHelpText(), Template.IconImage, true,, Template.AbilitySourceName);
	StatEffect.TargetConditions.AddItem(TargetCondition); // prevent exclusion on effect apply instead of in targeting
	StatEffect.AddPersistentStatChange (eStat_DetectionModifier, 1.00f);
	StatEffect.bRemoveWhenTargetDies = true;
	Template.AddMultiTargetEffect(StatEffect);

	ActionPointsEffect = new class'X2Effect_GrantRelocatePoints';
	ActionPointsEffect.NumActionPoints = 2;
	ActionPointsEffect.PointType = class'X2CharacterTemplateManager'.default.MoveActionPoint;
	ActionPointsEffect.bApplyOnMiss = true;
 	Template.AddMultiTargetEffect(ActionPointsEffect);

	//Template.bShowActivation = true;
	Template.bSkipFireAction = true;

	//Template.CinescriptCameraType = "Psionic_FireAtUnit";

	Template.AdditionalAbilities.AddItem('IsmsRelocateStealth');

	ImpairingAbilityEffect = new class 'X2Effect_ImmediateAbilityActivation';
	ImpairingAbilityEffect.BuildPersistentEffect(1, false, true, , eGameRule_PlayerTurnBegin);
	ImpairingAbilityEffect.EffectName = 'IsmsRelocateStealth';
	ImpairingAbilityEffect.AbilityName = 'IsmsRelocateStealth';
	ImpairingAbilityEffect.bRemoveWhenTargetDies = true;
	Template.AddShooterEffect(ImpairingAbilityEffect);



	Template.bCrossClassEligible = false;
	Template.TargetingMethod = class'X2TargetingMethod_Cone';

	Template.CustomFireAnim = 'HL_SignalPoint';
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildInterruptGameStateFn = TypicalAbility_BuildInterruptGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	Template.CinescriptCameraType = "Mark_Target";

	//Template.BuildVisualizationFn = class'X2Ability_AdventCaptain'.static.TargetGettingMarked_BuildVisualization;

	return Template;
}

static function X2AbilityTemplate IsmsRelocateStealth()
{
	local X2AbilityTemplate				Template;
	local X2AbilityCost_ActionPoints	ActionPointCost; 
	local X2Condition_UnitProperty      TargetCondition;
	local X2AbilityCooldown             Cooldown;
	local X2AbilityTarget_Cursor        CursorTarget;
	local X2AbilityMultiTarget_AllAllies	MultiTargetingStyle;	
	local X2AbilityTrigger_PlayerInput	InputTrigger;
	local X2Effect_Persistent				MarkedEffect; 

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsRelocateStealth');

	// Icon Properties
	Template.AbilitySourceName = 'eAbilitySource_Standard';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;	
	Template.IconImage = "img:///UILibrary_Rogue2.UIPerk_stealth_move2";
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_CORPORAL_PRIORITY;
	Template.Hostility = eHostility_Neutral;
	Template.DisplayTargetHitChance = false;
 
	
	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 0;
	ActionPointCost.bConsumeAllPoints = false;
	Template.AbilityCosts.AddItem(ActionPointCost);

	Cooldown = new class'X2AbilityCooldown';
	Cooldown.iNumTurns = 3;
	Template.AbilityCooldown = Cooldown;

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;

	CursorTarget = new class'X2AbilityTarget_Cursor';
	CursorTarget.bRestrictToWeaponRange = true;
	Template.AbilityTargetStyle = CursorTarget;

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	Template.AddShooterEffectExclusions();
 

	MarkedEffect = class'X2Effect_RogueCreateMarkedEffect'.static.CreateRelocateStealthEffect(2, false); 
	Template.AddMultiTargetEffect(MarkedEffect); 


	Template.AbilityTargetStyle = default.SelfTarget;
	MultiTargetingStyle = new class'X2AbilityMultiTarget_AllAllies';
	MultiTargetingStyle.bAllowSameTarget = true;
//	MultiTargetingStyle.NumTargetsRequired = 1; //At least someone must need healing
	Template.AbilityMultiTargetStyle = MultiTargetingStyle;

 	InputTrigger = new class'X2AbilityTrigger_PlayerInput';
	Template.AbilityTriggers.AddItem(InputTrigger);

	TargetCondition = new class'X2Condition_UnitProperty';
	TargetCondition.ExcludeAlive = false;
	TargetCondition.ExcludeConcealed = true;
	TargetCondition.ExcludeHostileToSource = true;
	TargetCondition.ExcludeFriendlyToSource = false;
	TargetCondition.RequireSquadmates = true;
	TargetCondition.FailOnNonUnits = true;
	TargetCondition.ExcludeDead = true;
	Template.AbilityMultiTargetConditions.AddItem(TargetCondition);

	 
	Template.bSkipFireAction = true;
	  

	Template.bCrossClassEligible = false;
	Template.TargetingMethod = class'X2TargetingMethod_Cone';

	Template.CustomFireAnim = 'HL_SignalPoint';
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildInterruptGameStateFn = TypicalAbility_BuildInterruptGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	Template.CinescriptCameraType = "Mark_Target";

	return Template;
}

static function X2AbilityTemplate IsmsScoutIntel()
{
	local X2AbilityTemplate						Template;
	local X2Effect_IntelCharges				Effect; 
	local X2AbilityTrigger_EventListener    Trigger;
	local X2Condition_UnitEffects			ShooterEffects;
 	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;
	local X2AbilityTarget_Cursor			CursorTarget;
	local X2AbilityMultiTarget_AllAllies	MultiTargetingStyle;	
	local X2Condition_UnitProperty      TargetCondition;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsScoutIntel');
	Template.AdditionalAbilities.AddItem('IsmsTactics');
	Template.AdditionalAbilities.AddItem('IsmsIntelReset');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_LeadByExample";	

	Template.bDisplayInUITooltip = false;
	Template.bdisplayinuitacticaltext = false;
		 
 	Trigger = new class'X2AbilityTrigger_EventListener';
	Trigger.ListenerData.Deferral = ELD_OnStateSubmitted;
	Trigger.ListenerData.EventID = 'PlayerTurnEnded';
	Trigger.ListenerData.Filter = eFilter_Player;
 	Trigger.ListenerData.EventFn = class'XComGameState_Ability'.static.AbilityTriggerEventListener_Self;
	Template.AbilityTriggers.AddItem(Trigger);
 
 	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;

	CursorTarget = new class'X2AbilityTarget_Cursor';
	CursorTarget.bRestrictToWeaponRange = true;
	Template.AbilityTargetStyle = CursorTarget;

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	Template.AddShooterEffectExclusions();

	Template.AbilityTargetStyle = default.SelfTarget;
	MultiTargetingStyle = new class'X2AbilityMultiTarget_AllAllies';
	MultiTargetingStyle.bAllowSameTarget = true;
	Template.AbilityMultiTargetStyle = MultiTargetingStyle;

	//InputTrigger = new class'X2AbilityTrigger_PlayerInput';
	//Template.AbilityTriggers.AddItem(InputTrigger);

	TargetCondition = new class'X2Condition_UnitProperty';
	TargetCondition.ExcludeAlive = false;
	TargetCondition.ExcludeHostileToSource = true;
	TargetCondition.ExcludeFriendlyToSource = false;
	TargetCondition.RequireSquadmates = true;
	TargetCondition.FailOnNonUnits = true;
	TargetCondition.ExcludeDead = true;
	Template.AbilityMultiTargetConditions.AddItem(TargetCondition);



 	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	PersistentStatChangeEffect.DuplicateResponse = eDupe_ignore;
	Template.AddMultiTargetEffect(PersistentStatChangeEffect);
 	

	Effect = new class'X2Effect_IntelCharges';
 //	Effect.AddPersistentStatChange(eStat_Mobility, 1);
 	Effect.AddPersistentStatChange(eStat_Defense, 1);
 	Effect.AddPersistentStatChange(eStat_Offense, 1);
	Effect.EffectName = 'IntelCharges';
	Effect.BuildPersistentEffect(6, false, false, false, eGameRule_PlayerTurnBegin);
	Effect.DuplicateResponse = eDupe_Allow;
	//Effect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	Template.AddMultiTargetEffect(Effect);

	//Effect = new class'X2Effect_PersistentStatChange';
 	//Effect.AddPersistentStatChange(eStat_Mobility, 1);
 	//Effect.AddPersistentStatChange(eStat_Defense, 1);
 	//Effect.AddPersistentStatChange(eStat_Offense, 1);
	//Effect.EffectName = 'Isms_NBKMobility';
	//Effect.BuildPersistentEffect(6, false, false, false, eGameRule_PlayerTurnBegin);
	//Effect.DuplicateResponse = eDupe_Allow;
	////Effect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	//Template.AddMultiTargetEffect(Effect);

	ShooterEffects = new class'X2Condition_UnitEffects';
 	ShooterEffects.AddExcludeEffect('Exhausted', 'AA_UnitIsNotMarked'); 
	//
 	Template.AbilityShooterConditions.AddItem(ShooterEffects);	
	//Template.AdditionalAbilities.AddItem('IsmsNBKGrandFinale');
 
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!


	return Template;
}
 
static function X2AbilityTemplate IsmsTactics()
{
	local X2AbilityTemplate                 Template;
//	local X2AbilityCooldown					Cooldown;
	local X2AbilityCost_ActionPoints		ActionPointCost;
	local X2AbilityCharges					Charges;
	local X2AbilityTarget_Single SingleTarget;
	local X2AbilityTrigger_PlayerInput InputTrigger;
	local X2Condition_UnitProperty TargetCondition;
	local X2Condition_Visibility TargetVisibilityCondition;
	local X2Condition_UnitEffects UnitEffectsCondition;
	local X2AbilityTarget_Cursor CursorTarget;
	local X2Effect_RestoreActionPoints      RestoreEffect;
	local X2Effect_ImmediateAbilityActivation ImpairingAbilityEffect;
	local X2AbilityCost_Charges             ChargesCost;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsTactics');

	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_LeadByExample";
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_Major_PRIORITY;
	Template.AbilitySourceName = 'eAbilitySource_Standard';
	Template.Hostility = eHostility_Neutral;
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";
	Template.DisplayTargetHitChance = false;

	//Template.bDisplayInUITooltip = false;
	//template.bdisplayinuitacticaltext = false;

	Template.AdditionalAbilities.AddItem('IsmsIntelReset');

	ImpairingAbilityEffect = new class 'X2Effect_ImmediateAbilityActivation';
	ImpairingAbilityEffect.BuildPersistentEffect(1, false, true, , eGameRule_PlayerTurnBegin);
	ImpairingAbilityEffect.EffectName = 'IsmsIntelReset';
	ImpairingAbilityEffect.AbilityName = 'IsmsIntelReset';
	ImpairingAbilityEffect.bRemoveWhenTargetDies = true;
	Template.AddShooterEffect(ImpairingAbilityEffect);

	//Cooldown = new class'X2AbilityCooldown';
	//Cooldown.iNumTurns = 4;
	//Template.AbilityCooldown = Cooldown;
//
 	Charges = new class'X2AbilityCharges';
	Charges.InitialCharges = 0; 
	Template.AbilityCharges = Charges;

	ChargesCost = new class'X2AbilityCost_Charges';
	ChargesCost.NumCharges = 5;
	Template.AbilityCosts.AddItem(ChargesCost);

	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 0;
	ActionPointCost.bConsumeAllPoints = false;
	Template.AbilityCosts.AddItem(ActionPointCost);	

	// The shooter cannot be mind controlled, bound, or carrying a unit.
	UnitEffectsCondition = new class'X2Condition_UnitEffects';
	UnitEffectsCondition.AddExcludeEffect(class'X2Effect_MindControl'.default.EffectName, 'AA_UnitIsMindControlled');
	UnitEffectsCondition.AddExcludeEffect(class'X2AbilityTemplateManager'.default.BoundName, 'AA_UnitIsBound');
	UnitEffectsCondition.AddExcludeEffect(class'X2Ability_CarryUnit'.default.CarryUnitEffectName, 'AA_CarryingUnit');
	Template.AbilityShooterConditions.AddItem(UnitEffectsCondition);
	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	Template.AddShooterEffectExclusions();

	CursorTarget = new class'X2AbilityTarget_Cursor';
	CursorTarget.bRestrictToWeaponRange = true;
	Template.AbilityTargetStyle = CursorTarget;

	// Can only shoot visible enemies
	Template.AbilityTargetConditions.AddItem(default.GameplayVisibilityCondition);
	// Can't target dead; Can't target friendlies
	//Template.AbilityTargetConditions.AddItem(default.LivingHostileTargetProperty);
	// Can't shoot while dead
	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	// Only at single targets that are in range.

	TargetCondition = new class'X2Condition_UnitProperty';
	TargetCondition.ExcludeAlive = false;
	TargetCondition.ExcludeHostileToSource = true;
	TargetCondition.ExcludeFriendlyToSource = false;
	TargetCondition.RequireSquadmates = true;
	TargetCondition.FailOnNonUnits = true;
	TargetCondition.ExcludeDead = true;
	Template.AbilityTargetConditions.AddItem(TargetCondition);
 
  
	RestoreEffect = new class'X2Effect_RestoreActionPoints';
//	RestoreEffect.TargetConditions.AddItem(new class'X2Condition_RevivalProtocol');
	Template.AddTargetEffect(RestoreEffect);

	// 100% chance to hit
	Template.AbilityToHitCalc = default.DeadEye;
	SingleTarget = new class'X2AbilityTarget_Single';
	Template.AbilityTargetStyle = SingleTarget;
	Template.AbilityTriggers.AddItem(InputTrigger);
	
	Template.CustomFireAnim = 'HL_SignalPoint';
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildInterruptGameStateFn = TypicalAbility_BuildInterruptGameState;
	Template.BuildVisualizationFn = class'X2Ability_AdventCaptain'.static.TargetGettingMarked_BuildVisualization;
	Template.CinescriptCameraType = "Mark_Target";

	Template.bCrossClassEligible = false;  

	return Template;
}

static function X2AbilityTemplate IsmsIntelReset()
{
	local X2AbilityTemplate						Template;
	local X2Effect_IntelCharges				Effect; 
	local X2AbilityTrigger_EventListener    Trigger;
	local X2Condition_UnitEffects			ShooterEffects;
 	local X2Effect_PersistentStatChange     PersistentStatChangeEffect;
	local X2AbilityTarget_Cursor			CursorTarget;
	local X2AbilityMultiTarget_AllAllies	MultiTargetingStyle;	
	local X2Condition_UnitProperty      TargetCondition;
 	local X2Effect_RemoveEffects			RemoveEffects;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsIntelReset');
 

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_LeadByExample";	

	 //
 	//Trigger = new class'X2AbilityTrigger_EventListener';
	//Trigger.ListenerData.Deferral = ELD_OnStateSubmitted;
	//Trigger.ListenerData.EventID = 'PlayerTurnEnded';
	//Trigger.ListenerData.Filter = eFilter_Player;
 	//Trigger.ListenerData.EventFn = class'XComGameState_Ability'.static.AbilityTriggerEventListener_Self;
	//Template.AbilityTriggers.AddItem(Trigger);
 
 	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;

	CursorTarget = new class'X2AbilityTarget_Cursor';
	CursorTarget.bRestrictToWeaponRange = true;
	Template.AbilityTargetStyle = CursorTarget;

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	Template.AddShooterEffectExclusions();

	Template.AbilityTargetStyle = default.SelfTarget;
	MultiTargetingStyle = new class'X2AbilityMultiTarget_AllAllies';
	MultiTargetingStyle.bAllowSameTarget = true;
	Template.AbilityMultiTargetStyle = MultiTargetingStyle;

 
	TargetCondition = new class'X2Condition_UnitProperty';
	TargetCondition.ExcludeAlive = false;
	TargetCondition.ExcludeHostileToSource = true;
	TargetCondition.ExcludeFriendlyToSource = false;
	TargetCondition.RequireSquadmates = true;
	TargetCondition.FailOnNonUnits = true;
	TargetCondition.ExcludeDead = true;
	Template.AbilityMultiTargetConditions.AddItem(TargetCondition);

 
  	RemoveEffects = new class'X2Effect_RemoveEffects';
	RemoveEffects.EffectNamesToRemove.AddItem('IntelCharges');
	RemoveEffects.bApplyOnMiss = true;
	RemoveEffects.bCleanse = true;
 	Template.AddMultiTargetEffect(RemoveEffects);
 

	ShooterEffects = new class'X2Condition_UnitEffects';
 	ShooterEffects.AddExcludeEffect('Exhausted', 'AA_UnitIsNotMarked'); 
	//
 	Template.AbilityShooterConditions.AddItem(ShooterEffects);	
	//Template.AdditionalAbilities.AddItem('IsmsNBKGrandFinale');
 
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!


	return Template;
}

//THE FOLLOWING CODE WAS BORROWED FROM DIVINE LUBRICATION'S ESCALATION CLASSES
static function X2AbilityTemplate IsmsFreeScanner()
{
	local X2AbilityTemplate									Template;
	local X2AbilityTargetStyle								TargetStyle;
	local X2AbilityTrigger									Trigger;
	local X2Effect_Isms_AddItem					 			AmmoEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'IsmsFreeScanner');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_Beags_Escalation_Icons.UIPerk_smokeandmirrors";

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);

	// This will tick once during application at the start of the player's turn and increase ammo of the specified items by the specified amounts
	AmmoEffect = new class'X2Effect_Isms_AddItem';
	AmmoEffect.EffectName = 'Isms_AddItem';
	AmmoEffect.BuildPersistentEffect(1, false, false, , eGameRule_PlayerTurnBegin); // Delay this until player turn begin so that any transient item effects are already applied
	AmmoEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, false,,Template.AbilitySourceName);
	AmmoEffect.DuplicateResponse = eDupe_Allow;
	AmmoEffect.AmmoCount = 1;
	AmmoEffect.ItemTemplateNames.Length = 0;
	AmmoEffect.ItemTemplateNames.AddItem('BattleScanner');
	Template.AddTargetEffect(AmmoEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!
	
	Template.bCrossClassEligible = true;

	return Template;
}

//static function X2AbilityTemplate FieldMedic()
//{
	//local X2AbilityTemplate         Template;
//
	//Template = PurePassive('FieldMedic', "img:///UILibrary_PerkIcons.UIPerk_fieldmedic");
	//Template.GetBonusWeaponAmmoFn = FieldMedic_BonusWeaponAmmo;
//
	//return Template;
//}
//
//function int FieldMedic_BonusWeaponAmmo(XComGameState_Unit UnitState, XComGameState_Item ItemState)
//{
	//if (ItemState.GetWeaponCategory() == class'X2Item_DefaultUtilityItems'.default.MedikitCat)
		//return default.FIELD_MEDIC_BONUS;
//
	//return 0;
//}