class X2Effect_RogueCloseRangeArmor extends X2Effect_BonusArmor;

var float DAMAGE_REDUCTION;
var float RANGE;

function int GetArmorChance(XComGameState_Effect EffectState, XComGameState_Unit UnitState) { return 100; }
function int GetArmorMitigation(XComGameState_Effect EffectState, XComGameState_Unit UnitState) { return 0; }

function int GetDefendingDamageModifier(XComGameState_Effect EffectState, XComGameState_Unit Attacker, Damageable TargetDamageable, XComGameState_Ability AbilityState, const out EffectAppliedData AppliedData, const int CurrentDamage, X2Effect_ApplyWeaponDamage WeaponDamageEffect)
{
	local int DamageMod;
	local XComGameState_Unit Targeted;

	Targeted =  XComGameState_Unit(`XCOMHISTORY.GetGameStateForObjectID(EffectState.ApplyEffectParameters.SourceStateObjectRef.ObjectID));

	if (class'Helpers'.static.IsTileInRange(Attacker.TileLocation, Targeted.TileLocation, RANGE))
	{
		DamageMod = -int(float(CurrentDamage) * DAMAGE_REDUCTION);
	}


	return DamageMod;
}

function GetToHitAsTargetModifiers(XComGameState_Effect EffectState, XComGameState_Unit Attacker, XComGameState_Unit Target, XComGameState_Ability AbilityState, class<X2AbilityToHitCalc> ToHitType, bool bMelee, bool bFlanking, bool bIndirectFire, out array<ShotModifierInfo> ShotModifiers)
{
	local ShotModifierInfo AccuracyInfo, CritInfo;


	//Targeted =  XComGameState_Unit(`XCOMHISTORY.GetGameStateForObjectID(EffectState.ApplyEffectParameters.SourceStateObjectRef.ObjectID));

	if (class'Helpers'.static.IsTileInRange(Attacker.TileLocation, Target.TileLocation, RANGE))
	{
		 
	AccuracyInfo.ModType = eHit_Success;
	AccuracyInfo.Value = -20;
	AccuracyInfo.Reason = FriendlyName;
	ShotModifiers.AddItem(AccuracyInfo);

	CritInfo.ModType = eHit_Crit;
	CritInfo.Value = 0;
	CritInfo.Reason = FriendlyName;
	ShotModifiers.AddItem(CritInfo);	
		
	}
}
