class X2Effect_RogueUpside extends X2Effect_Persistent;

var int BonusDamage;
var int StartingMobility;
var int StartingDodge;

simulated protected function OnEffectAdded(const out EffectAppliedData ApplyEffectParameters, XComGameState_BaseObject kNewTargetState, XComGameState NewGameState, XComGameState_Effect NewEffectState)
{
	local XComGameState_Unit TargetUnitState;
	local int StartingMobility;
 	local UnitValue OriginalMobilityValue;
 	local UnitValue OriginalDodgeValue;	 

 	TargetUnitState = XComGameState_Unit(kNewTargetState);
  	StartingMobility = TargetUnitState.GetCurrentStat(eStat_Mobility); 
	StartingDodge = TargetUnitState.GetCurrentStat(eStat_Dodge); 
	TargetUnitState.GetUnitValue('OriginalDodgeValue', OriginalDodgeValue); 
	TargetUnitState.SetUnitFloatValue('OriginalDodgeValue', StartingDodge, eCleanup_BeginTactical);

	TargetUnitState.GetUnitValue('OriginalMobilityValue', OriginalMobilityValue); 
	TargetUnitState.SetUnitFloatValue('OriginalMobilityValue', StartingMobility, eCleanup_BeginTactical);
  
}




function int GetAttackingDamageModifier(XComGameState_Effect EffectState, XComGameState_Unit Attacker, Damageable TargetDamageable, XComGameState_Ability AbilityState, const out EffectAppliedData AppliedData, const int CurrentDamage, optional XComGameState NewGameState)
{
	local XComGameState_Unit TargetUnit;
	local GameRulesCache_VisibilityInfo VisInfo;
	local XComGameState_Item SourceWeapon;  ///Here Delete

	SourceWeapon = AbilityState.GetSourceWeapon();
	TargetUnit = XComGameState_Unit(TargetDamageable);
	//`RedScreen("arrActorsToSwap will swap to self in OSP: " $ string(SourceWeapon.objectID));

	If (Attacker.Getrank() <=2)
	{
	BonusDamage = 1;
	}
	If ((Attacker.Getrank() > 2 ) && (Attacker.Getrank() <= 4))
	{
	BonusDamage = 2;
	}
	If ((Attacker.Getrank() > 4 ) && (Attacker.Getrank() <= 6))
	{
	BonusDamage = 3;
	}
	If (Attacker.Getrank() > 6 )
	{
	BonusDamage = 4;
	}

	//if (SourceWeapon != none) 
	If (SourceWeapon.GetWeaponCategory() != 'grenade')
	{
	If (CurrentDamage > 1)
	{	
		
	if (!AbilityState.IsMeleeAbility() && TargetUnit != None && class'XComGameStateContext_Ability'.static.IsHitResultHit(AppliedData.AbilityResultContext.HitResult))
	{
		if (`TACTICALRULES.VisibilityMgr.GetVisibilityInfo(Attacker.ObjectID, TargetUnit.ObjectID, VisInfo))
		{


			if (Attacker.HasHeightAdvantageOver(TargetUnit, true))
			{
				return BonusDamage;
			}
			  
		}
	}
	}
	}
	return 0;
	
}

