// This is an Unreal Script
class X2StrategyElement_AcademyUnlocksRogue extends X2StrategyElement;

static function array<X2DataTemplate> CreateTemplates()
{
	local array<X2DataTemplate> Templates;
		
	Templates.AddItem(kernEye());

	return Templates;
}

static function X2SoldierAbilityUnlockTemplate kernEye()
{
	local X2SoldierAbilityUnlockTemplate Template;
	local ArtifactCost Resources;

	`CREATE_X2TEMPLATE(class'X2SoldierAbilityUnlockTemplate', Template, 'kernEye');

	Template.AllowedClasses.AddItem('TheRogueClass');
	Template.AbilityName = 'kernEye';
	Template.strImage = "img:///UILibrary_StrategyImages.GTS.GTS_LightningStrike";


	// Requirements
	Template.Requirements.RequiredHighestSoldierRank = 5;
	Template.Requirements.RequiredSoldierClass = 'TheRogueClass';
	Template.Requirements.RequiredSoldierRankClassCombo = true;
	Template.Requirements.bVisibleIfSoldierRankGatesNotMet = true;

	// Cost
	Resources.ItemTemplateName = 'Supplies';
	Resources.Quantity = 75;
	Template.Cost.ResourceCosts.AddItem(Resources);

	return Template;
}